QQ登录

只需一步,快速开始

扫一扫,访问微社区

登录 | 注册 | 找回密码

三维网

 找回密码
 注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

展开

通知     

系统
[系统通知] 每周精选(11/11)
1天前
系统
3天前
查看: 4413|回复: 55
收起左侧

[分享] 分享学习AutoCAD编程之VBA笔记 (期初完结!)

[复制链接]
发表于 2019-3-24 12:08:39 | 显示全部楼层 |阅读模式
画图
主题分类用于问题归类:

马上注册,结识高手,享用更多资源,轻松玩转三维网社区。

您需要 登录 才可以下载或查看,没有帐号?注册

x
本帖最后由 kuangben8 于 2019-7-1 13:15 编辑
# c3 t! z* Z5 l3 m2 w+ Z; x  f  q* _/ |7 [$ G
分享AutoCAD编程之VBA笔记
" F/ e6 a! A3 W1 N1 h% p4 ^
7 t! `) ^$ H* h" l( s
      本人是从Excel编程转到AutoCAD编程学习的,目的是想实现Excel与AutoCAD之间数据交互,实现自动绘图的功能!期望于解决平常工作中的繁琐绘图与反复修改的麻烦。
, ?: s' D; Z- z4 u1 T. J" s/ i
$ x5 i, C: \0 @      作为AutoCAD编程完全小白的我,很庆幸自己在学习的过程中遇到了咱们论坛的版主woaishuijia老师手把手式教学辅导!每次遇到不理解的问题都会去请教woaishuijia老师,而老师也总是会耐心的答疑、细心的解惑、不厌其烦的亲自写示例讲解,并且不断的扩展我的知识面!如果没有woaishuijia老师的热心帮助,那么我的学习之路将会漫长很多,甚至会严重打击我的学习热情和信心!; F7 y. V( p7 M% z8 N  ]/ N$ c+ n
. `7 s' X! ?% K5 Q) u
      所以在此我想对woaishuijia老师说一声:感谢!感谢您的热心帮助,感谢您细心、耐心的答疑解惑,感谢您循序渐进的扩展我的知识面!没有您,我就不可能在短时间内完成我的初期目标。" f/ N/ u- P/ q

9 F+ [: g6 W( V, F- O' t      取之于论坛,用之于论坛,在此也分享一下本人这段时间来的学习笔记,期望于给那些想学习CAD的VBA编程还没有门路的友人们一点绵薄之力。
3 n" i0 o2 z+ o9 i
0 {/ O5 c* q# V: v0 m# w' N      说明:以下分享的内容都是本人的学习笔记,在学习过程中是遇到一个问题解决一个问题,遇到一个知识点总结一个知识点。所以内容排版不一定最合理,错误也在所难免!若各位看官发现错误之处,还望指正!
7 B  Y9 L. L6 }以下是本次分享内容的目录:/ A) e0 v5 Z4 I& r/ d' u2 b
8 c* ]: j' E: X% c7 Q9 p1 P# q
一、AutoCAD编程与Excel编程的不同
    1、编程环境不同带来的麻烦 点击
    2、学习中的参考资料
    3、AutoCAD中程序的保存与修改 点击
       A、单次加载VBA宏的方法
       B、自动加载工程代码方法
    4、让AutoCAD界面显示单步运行的结果 点击
二、初识AutoCAD编程对象与方法
    1、直线命令(LINE) 点击
    2、二维多段线命令(LightWeightPolyline) 点击
    3、圆命令(Circle) 点击
       A、根据圆心和半径画圆方法:AddCircle(圆心坐标,半径)
       B、根据三点坐标画圆
       C、根据两点直径画圆
    4、圆弧命令(Arc) 点击
       A、指定四个基本参数画弧
       B、根据三点画弧
       C、起点、端点、半径画弧 点击
    5、对象操作方法之偏移、镜像
       A、Object.Offset方法 点击
       B、Object.Mirror方法 点击
    6、设置对象属性之颜色、线宽、线型、比例、图层
       A、添加线型 点击
       B、设置对象属性之颜色 点击
       C、设置线宽和比例 点击
       D、添加图层 点击
    7、添加文字(AddMText) 点击
    8、对象操作方法之复制、旋转、移动 点击
       A、Object.Copy方法
       B、Object.Rotate方法
       C、Object.Move方法
    9、常用对象的常用方法、属性、事件
       A、常用对象的方法列表 点击
       B、常用对象的事件列表
       C、常用对象的属性列表
       D、常用方法示例 点击
       E、常用属性示例 点击
       F、常用事件示例
    10、辅助绘图方法
       A、辅助三点画圆 点击
       B、辅助三点画弧 点击
       C、辅助两点半径画弧 点击
    11、对象操作方法之图案填充(AddHatch)
       A、创建图案填充 点击  创建图案填充的补充
       B、图案填充的常用方法 点击
       C、图案填充的常用属性 点击
    12、很有用的Utility对象
       A、Utility对象 点击
       B、. AngleFromXAxis方法 点击
       C、.AngleToReal方法
       D、.AngleToString方法
       E、.CreateTypedArray方法 点击
       F、.GetAngle方法
       G、.GetCorner方法 点击
       H、.GetDistance方法
       I、.GetEntity方法 点击
       J、.GetInput方法
       K、.GetInteger方法 点击
       L、.GetKeyWord方法
       M、.GetOrientation方法 点击
       N、.GetPoint方法
       O、.GetReal方法 点击
       P、. GetRemoteFile方法
       Q、.GetString方法
       R、.GetSubEntity方法 点击
       S、.InitalizeUserInput方法
       T、.IsRemoteFile方法
       U、.IsURL方法 点击
       V、.LaunchBrowserDialog方法
       W、.PolarPoint方法
       X、.Prompt方法
       Y、.PutRemoteFile方法
       Z、.RealToString方法 点击
       AA、.SendModelessOperationEnded方法
       AB、.SendModelessOperationStart方法
       AC、.TranslateCoordinates方法
    13、使用Utility对象手动辅助绘图示例 点击
       A、手动三点画弧
       B、手动三点画圆
       C、手动两点半径画弧
    14、手动取点画图时添加提示线 点击
       A、手动画一条直线
       B、手动画圆
    15、样条曲线对象(SpLine) 点击
       A、添加样条曲线方法(AddSpline)
       B、样条曲线对象(SpLine)的常用方法及属性
       C、画函数曲线 点击
    16、椭圆对象(Ellipse)
       A、添加椭圆方法(AddEllipse) 点击
       B、椭圆对象(Ellipse)的常用方法及属性 点击
       C、创建椭圆弧对象 点击
三、实现Excel与AutoCAD之间数据交互
    1、通过Excel编程调用指定AutoCAD文档自动画图 点击
    2、通过AutoCAD编程调用Excel数据自动绘图 点击
$ G5 [+ D* L2 i- P

; g% b, v" O6 A
; m3 ~# U/ n5 j# d

& E1 j9 m1 \# b$ q4 x+ h9 r
2 y6 x0 R( R6 Z7 I4 p

评分

参与人数 1三维币 +80 收起 理由
2005llnn + 80 鼓励分享,好资料!

查看全部评分

此贴共有 154 人浏览过
 楼主| 发表于 2019-3-24 12:08:40 | 显示全部楼层
本帖最后由 woaishuijia 于 2019-3-30 04:48 编辑
, {- b0 G, {+ i! ^3 H( i# ~1 y' X7 w6 _' f6 g. B+ k6 a
1、编程环境不同带来的麻烦
自AutoCAD2010版本开始,VBA模块就已经不随软件自行安装,因此想在AutoCAD中编写VBA代码,首先需要下载(2016版本之后的网上很容易搜到)对应版本AutoCAD的VBA模块安装。
但是安装的VBA模块自带的帮助文件全是英文版本的!更可恨的是AutoCAD的VBA里没有像OFFICE那样的录制宏功能(What!!!)。
在对AutoCAD的VBA对象、属性、方法一无所知的情况下,我该怎么学习VBA呢?难道逼我退出吗?那我的理想怎么办(虽然不知道理想是什么)!!
方法总比困难多。。。。。。。。。。。。
2、学习中的参考资料
处于这个时代的最大好处是:当你决心去做成一件事的时候,你会发现早已有人做成了这件事,而且还免费的分享了一堆技术资料、示例、经验。。。。。。
什么?你问我在哪?
知道你的钥匙丢了去哪里找吗?百度啊!!
在此也分享一些本人学习的参考资料链接:(三维网的技术分享)当然后续学习主要依靠自己摸索和请教老师!(论有个好老师的重要性!)
    网络上免费分享的帖子、资料不计其数,初始时总像发现宝一样的疯狂下载到自己的电脑硬盘里,但是最后发现存储了很多!但是拥有的很少!因为人家的心不在你这里!
    简述一下本人的学习观点:可以做疯狂的学习者,但不要做疯狂的下载者!勤动手、多总结!
另外在ExcelHome论坛里有一篇帖子非常好:相信、实践、理解!
' j! y/ O' x+ U+ j  A; s8 f
 楼主| 发表于 2019-3-24 12:08:41 | 显示全部楼层
本帖最后由 woaishuijia 于 2019-3-30 04:57 编辑 2 m) S) p6 V$ ]! ~* w9 {! ?
% j4 o8 x* g- m: H
3、AutoCAD中程序的保存与修改
; \- U0 N+ E" B2 H2 [
通过观摩大神的技术分享并亲自动手试验一下,相信你对AutoCAD里VBA的的对象、方法、属性有了一点概念上的理解。
但是当你在AutoCAD的VBA里写完代码后满心欢喜的保存、关闭,以为下次打开后点击一下就自动运行了!哈哈哈,多刁!在打开的那一瞬间你是泪奔的!我写的代码哪里去了??
这里要说的是AutoCAD的VBA代码保存方式和Excel很不同!不是有专门的对应格式文件,也不是直接存储在这个文档里!而是单独保存在一个叫“Project.dvb”的文件里(Project是文件名可以修改),那是AutoCAD自己的工程代码类文件,需要额外加载。
以下内容原文链接地址:地址贴的第29楼层
A、单次加载VBA宏的方法
1、直接加载:
AutoCAD图形界面菜单:“工具”> “宏” > “加载工程”
或功能区 :“管理” > “应用程序” > “加载工程”
或命令行:VBALOAD
在弹出的对话框中找到你的VBA工程库名.dvb文件,打开、加载。返回到VBE窗口就能看见代码了。
2、通过VBA管理器加载:
首先打开VBA管理器,方法是:
CAD图形界面菜单:“工具”> “宏” > “VBA管理器”
或功能区 :“管理” > “应用程序” > “VBA管理器”
或命令行:VBAMAN
然后在弹出的“VBA管理器”上点击“加载”按钮。
同样在弹出的对话框中找到你的VBA工程库名.dvb文件,打开、加载。返回到VBE窗口就能看见代码了。
不过上述方法的缺点是每次重新打开AutoCAD时都需要这么操作一次,才能加载上你的工程代码。
    3卸载VBA宏的方法:
首先打开VBA管理器(方法同上),然后在列表框中选择要卸载的宏,点击“卸载”按钮
B、自动加载工程代码方法
想要AutoCAD文档打开可以自动加载工程代码大约有如下几种方法:
以下原文的地址链接:cad 自动加载vba程序
1vba自己加载法:将你的vba工程文件改名为acad.dvb,放在cad的安装目录下,vba初始化后自动加载。
2startup加载法:将你的vba文件放到cad的安装目下。cad安装目录下和suport目录下搜索acad.lsp文件,如果不存在,用windows记事本在安装目录下新建一个acad.lsp文件(如果已经存在,用记事本打开它),在该文件中添加如下内容:
(defunS::STARTUP()
(command"_VBALOAD" "myproj.dvb")
)
保存后退出,以后启动cad会自动加载,其中myproj.dvb你的vba工程文件名
以上是autodesk推荐的两种方法,其实还有第三种方法。
3lisp加载法。用记事本打开support目录下的acad20xx.lsp,其中20xx与acad的版本对应(如acad2000对应acad2000.lsp,acad2012对应acad2012.lsp等等),在文件的最后添加如下语句:
(vl-vbaload"myproj.dvb")
同样,vba工程文件名。保存后退出,以后可自动加载了。3 ?9 P+ |6 |9 X( V
 楼主| 发表于 2019-3-24 12:08:42 | 显示全部楼层
本帖最后由 kuangben8 于 2019-3-25 20:45 编辑
% k9 q/ G- q% @, _% v5 i( \/ Z- \( e, U8 ?1 i" Z, D3 e0 V* G. |( A
4、让AutoCAD界面显示单步运行的结果
正常运行AutoCAD工程中的代码时,在CAD界面上看不见运行过程的,直到代码运行完后界面自动刷新,才会出现代码执行的结果。如果希望像Excel里那样单步执行可以看见过程,必须在程序中使用Update来刷新数据,但是刷新数据会耗费电脑内存资源,所以不是单步执行或者必须想看过程,不建议使用Update,因为必须每一步下面都要写上Update才能实现步步可见的效果。
  1. Sub 刷新界面()
    ' c7 g: D4 ^# }  y3 N
  2.     Dim pt01(2) As Double, pt02(2) As Double,n%      '定义两个点变量,再定义一个循环变量
    / k( K3 j9 v% T; U9 _: U" o' D( B
  3.     Dim l As AcadLine, cir As AcadCircle         '定义直线和圆变量,AcadLine是CAD中对象“直线”的类名,只有定义为指定的类名,CAD才知道你定义的这个变量是什么!$ M7 v& I% s& }) E9 w9 s
  4.     For n = 1 To 10                             '给循环变量n指定循环次数,从1 到10,默认每次增加1,即1,2,3,4,5,6,7,8,9,10
    ; O' z- Y/ b  ^) g
  5.         pt01(0) = 10 * (n - 1)              '通过2楼链接里的帖子,相信你已经知道接下来的6句是干什么了吧?
    7 }" \' a: p0 l: D  [$ e
  6.         pt01(1) = 10 * (n - 1)
    : T* z1 |  N7 O: l& Z. W
  7.         pt02(0) = pt01(0) + 50
    " U. N1 P: D5 [. w$ {
  8.         pt02(1) = pt01(1) + 0
    - h2 o. w6 U# _3 @6 d4 s
  9.         Set l =ThisDrawing.ModelSpace.AddLine(pt01, pt02)( C7 U1 Q( t2 Q; d' |
  10.         Set cir =ThisDrawing.ModelSpace.AddCircle(pt01, 50)
    7 x! _; O$ \+ f2 z& I
  11.         update    '方法一、直接刷新( C+ o4 e2 T* q: g- ]) J
  12.         l.update  '方法二、对象刷新  '可以指定任一对象刷新,效果都是屏幕刷新: X. z! a* m: ~1 Z7 }& `
  13.         ThisDrawing.Application.update   '方法三、使用当前画布对象刷新3 h; Z* s0 ^( S0 s2 X7 c1 D
  14.     Next' ^0 R7 r/ _( ?# I
  15. End Sub
复制代码
1.4、刷新界面Update.zip (5.58 KB, 下载次数: 4)
 楼主| 发表于 2019-3-24 17:17:35 | 显示全部楼层
本帖最后由 kuangben8 于 2019-3-25 20:49 编辑 ' ?' |/ Y! b! g" w% {
/ N- p! z6 [: [$ W
二、初识AutoCAD编程对象与方法
在你熟悉VBA编程的基本知识后,学习AutoCAD编程则要方便的多。虽然对象及其属性、方法不知道,也没办法录制宏!好在我们需要用到的对象也不用太多,先从直线、圆、圆弧、多段线等常用命令开始慢慢的积累。
1、直线命令(LINE)
在AutoCAD中画直线需要指定点的位置,CAD的模型空间相当于一个无限大的三维空间,因此绘制直线时指定的点的位置可以由三维坐标(x,y,z)来对应确定,如果只是在XY平面上画图,则Z坐标在赋值时可以省略(默认为0),但是定义点的坐标数组时必须是3个元素。
画直线的方法:AddLine(起点坐标,终点坐标)
  1. Sub 画直线()
    & _2 A- H9 R+ `
  2.     Dim L01 As AcadLine   '定义直线对象变量
    & X6 k5 a2 z3 L1 t
  3. '    Dim L02 As AcadLine- b  t8 V# H0 L- h
  4. '    Dim L03 As AcadLine
    ; I2 [) R6 m. b- p* R2 ]
  5.     Dim P01(0 To 2) As Double          '定义点数组变量,类型为双精度型(范围大,含小数),数组元素下标为0、1、2& s) Y7 _& @  @8 n2 e' O5 g1 l
  6.     Dim P02(2) As Double                '同上,单独一个数字表示数组元素下标的上限(最大值),默认从0开始,所以是0、1、2, n  ?" s. M" b* A# z" A
  7.     Dim P03(1 To 3) As Double         '同上,数组下标的下限可以自由设定,一般从1开始,所以设为1、2、3: V8 t* o( D. T' L  N% X
  8.     Dim P04(2 To 4) As Double         '同上,数组元素下标也可以设置为2、3、45 I# |/ o& a& Z' }: S& w
  9.     P01(0) = -500: P01(1) =0          '对点的坐标数组元素分别赋值,可省略  : P01(2) = 0,多行语句合在一行写时用:连接
    : x3 G* }) Z; k' r8 D2 L* u
  10.     P02(0) = 500: P02(1) = 0:P02(2) = 0           '按照先后顺序,对应该点的X、Y、Z坐标值
    + T, t5 s% u1 a+ `  R
  11.     P03(1) = -600: P03(2) = 1000:P03(3) = 0
    / y" g6 M' Z8 a
  12.     P04(2) = 600: P04(3) =1000                        'z坐标值省略,默认是0" a. j1 q2 \% R" c7 ^/ w8 l
  13.     With ThisDrawing.ModelSpace                      '在当前画布的模型空间里,with...end with语句简化代码的作用2 d7 [) n4 x+ T, I7 p& h# C
  14.         Set L01 = .AddLine(P01, P02)      '给对象赋值要用set,画直线的参数(起点坐标,终点坐标)要加括号! @" o8 ^* l6 y2 \% x2 x
  15.         Call .AddLine(P01, P03)               '未定义对象时可以用call调用对应的过程或方法,参数也要加括号
    # s8 m" s, i' B2 O, l6 p  [
  16.         .AddLine P02, P04                        '也可以直接画,但此时画直线的参数不能加括号
    6 `. h4 c6 Q1 |$ D: _  Z, B
  17.     End With
    ; ~5 \7 ]- k. s, B: f
  18. End Sub
复制代码

. F% G1 n! R& ^+ t6 {
2.1、画直线.zip (4.65 KB, 下载次数: 5)
 楼主| 发表于 2019-3-25 20:55:42 | 显示全部楼层
本帖最后由 kuangben8 于 2019-3-25 20:58 编辑 + k; L+ f0 x" A: V) A9 z
, t1 _) F* M# r9 a' c
2、二维多段线命令(LightWeightPolyline)
    AutoCAD中多段线的作用是可以将多条线段、圆弧等对象连成一个整体,当然还有很多后续操作的方便之处(例如整体偏移等)
二维多段线在定义点的坐标时默认Z坐标为0(省略),多段线的连续点的坐标组成一个数组。数组中每两个元素值作为一个点的X、Y坐标值,所以二维多段线的点坐标数组的元素个数一定是偶数!画二维多段线方法:AddLightWeightPolyline(点坐标的数组集合)
  1. Sub 画多段线()' H  ^5 _1 [/ v% q
  2.     Dim pl As AcadLWPolyline   '定义二维多段线对象变量8 J3 z$ W; ^& Q( x
  3.     Dim pt1(1 To 8) As Double
    0 R* O4 t1 ]+ V3 c' W
  4.     Dim pt2(1 To 3) As Double, pt3(1 To 3) As Double   '直线端点需要3个坐标,赋值时可以省略z坐标0
    4 e" \3 Q. W% c" D8 f  l
  5.     Dim pt4(1 To 3) As Double, pt5(1 To 3) As Double   '直线端点需要3个坐标,赋值时可以省略z坐标0
    4 F) f. D6 G8 |/ H* z
  6.     Dim pt6(1 To 8) As Double, pt7(1 To 8) As Double
    7 h, y' _! j+ ~9 h$ j: c
  7.     Dim n%, pts(1 To 10) As Double  '画矩形
    " Z; [* f8 F; _) b
  8.     pt1(1) = -1600: pt1(2) = 3000  '每两个点作为一条二维多段线的一个端点坐标,默认z坐标为0省略。6 }7 a  L' W, Z) a! K" j& ~
  9.     pt1(3) = -1400: pt1(4) = 0
    ! b4 L# L9 S8 @
  10.     pt1(5) = 1400: pt1(6) = 0
    ; L. V& p* [# L' S" |  D* K2 n
  11.     pt1(7) = 1600: pt1(8) = 3000  i" t  f8 \  m9 J
  12.     Set pl = ThisDrawing.ModelSpace.AddLightWeightPolyline(pt1)  '第一种赋值语句9 |6 S: O3 Z" W8 E7 G% {
  13.     pt2(1) = -1400.666667: pt2(2) = 10# V5 o; m0 L* `6 n/ x9 E! q
  14.     pt3(1) = 1400.666667: pt3(2) = 10
    $ m$ p5 K& L. Y7 ~. I
  15.     ThisDrawing.ModelSpace.AddLine pt2, pt3
      h6 P% e. ?/ B
  16.     pt4(1) = -1410.666667: pt4(2) = 160  X! F( N- C6 c5 o1 z* Z( [* \2 E
  17.     pt5(1) = 1410.666667: pt5(2) = 1601 d8 x2 @6 N5 w2 P  y, K! z. @
  18.     ThisDrawing.ModelSpace.AddLine pt4, pt5
    6 J/ }: `& t& E; L  l1 N
  19.     pt6(1) = -1589.977802: pt6(2) = 3000  '每两个点作为一条二维多段线的一个端点坐标,默认z坐标为0省略。
    # W/ Z1 |: a: ?0 ^
  20.     pt6(3) = -1400.644469: pt6(4) = 160
    " \. O  F% P3 ^- _& a  S+ b
  21.     pt6(5) = -1310.444691: pt6(6) = 160
    ( u& F, r- T% @' k7 X) o
  22.     pt6(7) = -1499.778024: pt6(8) = 3000
    ( O# Y- |9 w2 E' P: ]2 M
  23.     Call ThisDrawing.ModelSpace.AddLightWeightPolyline(pt6)  '第二种赋值语句
    6 S6 f/ m" j, T3 `2 E
  24.     pt7(1) = 1589.977802: pt7(2) = 3000  '每两个点作为一条二维多段线的一个端点坐标,默认z坐标为0省略。
    / w, Y* O2 E& }* }% |
  25.     pt7(3) = 1400.644469: pt7(4) = 160
    % u) P/ D" K  x8 s3 Z: T
  26.     pt7(5) = 1310.444691: pt7(6) = 1602 c' t2 a* a: S- w6 d  v6 o
  27.     pt7(7) = 1499.778024: pt7(8) = 30006 ]0 ]. H9 }# \- M
  28.     ThisDrawing.ModelSpace.AddLightWeightPolyline pt7  '第三种赋值语句: R4 e( Z7 C. p2 e: R
  29.     For n = 1 To 28    '循环画矩形
    : T5 i( S+ J5 Y/ a' m( f
  30.         If n <= 12 Then  '不同的n值对应的矩形不同,添加一个判断9 d0 w* H6 T1 s
  31.             pts(1) = -(n - 1) * 100 * 0.133333333333333 / 2 + pt6(5): pts(2) = (n - 1) * 100 + pt6(6)
    . L7 I, R: l0 I; V4 V
  32.             pts(3) = pts(1) + 180: pts(4) = pts(2)
    0 f1 F6 b8 f+ |" ~) K8 z, Z; `
  33.             pts(5) = pts(3): pts(6) = pts(4) + 100
    5 S, \" E1 C1 |$ i, J
  34.             pts(7) = pts(5) - 180: pts(8) = pts(6)
    4 }, m' s0 ?! j0 [0 [1 o, b0 I
  35.             pts(9) = pts(1): pts(10) = pts(2)
    ) Y& ~" t1 |0 a  o6 X/ E
  36.         ElseIf n <= 20 Then
    7 u% k! _' Y8 P" O( y2 D# k: O
  37.             pts(1) = -(n - 1) * 100 * 0.133333333333333 / 2 + pt6(5): pts(2) = (n - 1) * 100 + pt6(6)
    # \8 {  U8 y  v" L0 o
  38.             pts(3) = pts(1) + 220: pts(4) = pts(2). x: l- t$ ~  X% G/ W+ ?! Z
  39.             pts(5) = pts(3): pts(6) = pts(4) + 100
    3 v7 `% c, l: I; H8 l
  40.             pts(7) = pts(5) - 220: pts(8) = pts(6)
    $ Z# F. S, }) j) w& k6 |
  41.             pts(9) = pts(1): pts(10) = pts(2)
    / ^' O* b4 h& p
  42.         Else1 I5 v' s+ b7 p* j/ H/ j
  43.             pts(1) = -(n - 1) * 100 * 0.133333333333333 / 2 + pt6(5): pts(2) = (n - 1) * 100 + pt6(6)
    6 k6 U  I" ~, V- u% t, l4 c+ E  {
  44.             pts(3) = pts(1) + 200: pts(4) = pts(2)  n4 \# P: b$ @! v( N, d* y
  45.             pts(5) = pts(3): pts(6) = pts(4) + 100
    0 D- I* X2 j/ g
  46.             pts(7) = pts(5) - 200: pts(8) = pts(6)
    2 r' D3 l4 t' D7 h; B/ B
  47.             pts(9) = pts(1): pts(10) = pts(2)( \* p. {7 L/ K$ N" R
  48.         End If, w4 N( H2 Q6 c8 w4 G+ a
  49.        ThisDrawing.ModelSpace.AddLightWeightPolyline pts  '绘制二维多段线& O# ~( N. K6 t4 @7 h  @6 Q2 X+ N
  50.     Next
    # j) L6 P6 m- k. J; t# e
  51. End Sub
复制代码
# [$ A2 a5 w4 E8 a/ o- s. N
2.2、画多段线.zip (8.09 KB, 下载次数: 2)
 楼主| 发表于 2019-3-25 21:06:23 | 显示全部楼层
3、圆命令(Circle)
在AutoCAD中绘制圆时,需要指定圆的圆心坐标和半径,似乎只有这一种方法,想要通过其他方法画圆(如经过3点画圆),需要根据3点求出圆心坐标和半径大小!
A、根据圆心和半径画圆方法:AddCircle(圆心坐标,半径)
  1. Sub 同心圆()   '画100个同心圆
    5 W& c& h6 g5 r6 J5 E; }
  2.     Dim cir As AcadCircle
    8 {* V6 g. |5 G  [
  3.     Dim pot(2) As Double
    % }: c3 M  ]6 H
  4.     Dim r As Double" Z+ }7 `. e* A. q# d4 P
  5.     Dim i
    8 [- n8 N7 P0 N* V
  6.     pot(0) = 1002 S9 _/ q* c  d: G
  7.     pot(1) = 100. l4 H$ m( x  x; @9 Y! `5 K
  8.     pot(2) = 100   'Z坐标相当于将图形位置从XY平面平移到Z坐标所在位置。, ]% s: U! [2 N
  9.     With ThisDrawing.ModelSpace& W$ @3 b6 ?; f. K/ x+ F1 T/ b
  10.         For i = 1 To 1000 Step 10
      x' o- `- O0 Y( G% K. p
  11.             r = i * 10% J) i6 F. u. f( [# \
  12.             Call .AddCircle(pot, r)    '第一种赋值语句
    & ?; P6 }+ X& [7 n7 f
  13.             Rem 上述语句中的call起到调用画圆的方法作用
    " |, Z3 Q: |% t. ]0 A$ {2 Q! \* S
  14.             Rem 使用 Call 关键字来调用一个需要参数的过程,argumentlist 就必须要加上括号。 _
    % u* E* `1 ^7 W7 H! {
  15.                 如果省略了 Call 关键字,那么也必须要省略 argumentlis 外面的括号1 ~# q9 v: E. w1 ~
  16. '            .AddCircle pot, r  '不用call时则参数argumentlis 外面的括号不能要!第二种赋值语句
    3 l! Y9 C! Q& M1 d  j) {0 j% l
  17. '        Set cir = .AddCircle(pot, r)  '第三种赋值语句
    8 F8 s( c8 A6 W' E" H% _8 |
  18.         Next) r; e. s. g1 a0 M8 d' H
  19.         Call MsgBox("100个同心圆已经绘制完毕!", vbOKOnly + vbInformation)6 I! x1 `3 W% F6 z
  20.         MsgBox "100个同心圆已经绘制完毕!", vbOKOnly + vbInformation
    * U" h7 d1 T4 Z5 R. d# t1 v( n) p
  21.     End With
      n: m2 r. T  ]6 R! e
  22. End Sub
复制代码

  Y( U* L- F  T: _7 j/ @  j
B、根据三点坐标画圆
首先根据三点坐标计算出圆心坐标和半径大小,然后画圆,关于计算方法,根据几何图形知识换算即可。
  1. Sub 三点画圆()
    ; L" g; l5 K+ Q5 l* W% u
  2.     Dim cir As AcadCircle# @/ ?* i1 u/ ~$ [0 Y
  3.     Dim pt1(2) As Double, pt2(2) As Double, pt3(2) As Double3 p$ Z; p) g4 J+ \; @: H
  4.     Dim A1#, B1#, C1#, A2#, B2#, C2#                   '定义中间变量为double类型,用于简化计算
    9 y% M8 h9 a7 f, m7 i& W: O) P
  5.     Dim pt0(2) As Double, r#                          '定义圆心坐标(X,Y)和半径r. @- R/ c  {5 w
  6.     pt1(0) = 120: pt1(1) = 105                         '第一点坐标(X1,Y1)
    + J: l8 l" h6 @: }
  7.     pt2(0) = 59: pt2(1) = 67                           '第二点坐标(X2,Y2)
    . L+ U+ ]/ T; s; i0 b
  8.     pt3(0) = 89: pt3(1) = 91                           '第三点坐标(X3,Y3)
    # a( C: @9 K+ i7 u' _( A
  9.     A1 = 2 * (pt2(0) - pt1(0))                          'A1=2*(X2-X1)4 n/ C; y/ v: }* a9 ^  B4 U) ]! h
  10.     B1 = 2 * (pt2(1) - pt1(1))                          'B1=2*(Y2-Y1)7 z& F! H1 F! J5 V$ |0 E* ~
  11.     C1 = pt2(0) ^ 2 - pt1(0) ^ 2 + pt2(1) ^ 2 - pt1(1) ^ 2     'C1=X2^2-X1^2+Y2^2-Y1^2
    6 M& P; {6 A. U
  12.     A2 = 2 * (pt3(0) - pt1(0))                          'A2=2*(X3-X1)
    ( v! a% a! F: h+ @
  13.     B2 = 2 * (pt3(1) - pt1(1))                          'B2=2*(Y3-Y1)  W# f5 p- H8 @
  14.     C2 = pt3(0) ^ 2 - pt1(0) ^ 2 + pt3(1) ^ 2 - pt1(1) ^ 2     'C2=X3^2-X1^2+Y3^2-Y1^23 f: d: l% k2 {% w
  15.     pt0(0) = (B1 * C2 - B2 * C1) / (A2 * B1 - A1 * B2)       'X=(B1*C2-B2*C1)/(A2*B1-A1*B2). M. X4 E' r, {$ K8 E
  16.     pt0(1) = (A2 * C1 - A1 * C2) / (A2 * B1 - A1 * B2)       'Y=(A2*C1-A1*C2)/(A2*B1-A1*B2)
    : ~# [$ a- \; f9 ]3 t
  17.     r = ((pt0(0) - pt1(0)) ^ 2 + (pt0(1) - pt1(1)) ^ 2) ^ 0.5    'r=((X-X1)^2+(Y-Y1)^2)^0.5
    1 x/ b0 Z. U5 a5 U: X+ d' p
  18.     With ThisDrawing.ModelSpace
    & X8 H9 s6 D# ]* _" |
  19.         Set cir = .AddCircle(pt0, r)
    3 M7 ?/ i. }6 [! O# H
  20.         Call .AddLine(pt1, pt2)                       '画这两条直线目的为了确认三点在圆上。
    ) z7 G/ o; J! s& _3 b
  21.         .AddLine pt2, pt3
    ! ^4 Q+ ~4 |- b
  22.     End With
    3 _6 F# q3 E# u5 P# Z- C  k- L. H
  23.     ZoomAll                                       '全部显示在窗口中( ~* M. `" @) @  J
  24. End Sub
复制代码
6 [5 w/ r) o1 n& [  B

; S# |$ X6 }. H" O5 j
C、根据两点直径画圆
求出相应的圆心坐标和半径即可画圆
  1. Sub 两点直径画圆()1 B% H8 [! a& s9 ?( S& X
  2.     Dim pt(3) As Double
    9 E- y* p  X( x8 L
  3.     Dim pt0(2) As Double, R#
    / d& A9 W' v3 f% A
  4.     pt(0) = 29: pt(1) = 35: pt(2) = 156: pt(3) = 286  s! F4 w2 ]! F& J9 V" Z
  5.     pt0(0) = (pt(0) + pt(2)) / 2
    # f! o6 n* I2 J
  6.     pt0(1) = (pt(1) + pt(3)) / 24 `8 g4 y' P3 Z. K$ ]. W
  7.     R = ((pt0(0) - pt(0)) ^ 2 + (pt0(1) - pt(1)) ^ 2) ^ 0.5; Y5 H% i. q) |. A# Q; r
  8.     ThisDrawing.ModelSpace.AddCircle pt0, R
    8 P! i2 a2 z2 R6 P1 e( J4 J8 }+ w
  9. End Sub
复制代码
2.3-画圆命令.zip (7.51 KB, 下载次数: 2)
 楼主| 发表于 2019-3-25 21:19:17 | 显示全部楼层
本帖最后由 kuangben8 于 2019-3-25 21:25 编辑 $ Z/ k9 q* A+ v3 y

' _! I1 J+ a  p/ q6 T1 f  I9 }4、圆弧命令(Arc)
AutoCADVBA中添加圆弧的方法也很单一:需要指定圆心,半径,起始角,终止角四个参数.
A、指定四个基本参数画弧
方法: RetVal = Object.AddArc(Center, Radius, StartAngle, EndAngle)
Object可以是模型空间、布局空间、块等对象,
Center圆弧中心点坐标,3个元素组成的数组(double类型),其中Z坐标默认0可省略,
Radius圆弧的半径,double类型,
StartAngleEndAngledouble类型,用于输入定义圆弧的起始角和终止角(以弧度表示)大小。
起始角度和终止角度的确认:以圆心所在水平轴为X轴,圆心位置为坐标原点,以X轴正半轴为角度的起始边,逆时针旋转对应度数就是指定的起始角或终止角。所以AutoCAD中圆弧均是逆时针绘制
弧的优劣:当起始角小于终止角时,角度差大于180°就是优弧,小于180°就是劣弧当起始角大于终止角(可以为负角)时,圆弧依然是从起始角位置逆时针绘制到终止角位置
RetVal结果是新绘制的圆弧对象。
  1. Sub 圆弧()
    % U! @. U1 B4 p3 t6 Z+ C
  2.     Dim arc As AcadArc   '定义圆弧对象( ]& i( L1 w+ Y$ A
  3.     Dim pot(1 To 3) As Double     '定义圆弧中心坐标点数组
    - c2 J6 E% Z  {: r
  4.     Dim R As Double     '定义半径1 f* `, b$ @6 i8 z/ ~% ?) u
  5.     Dim stq As Double, edq As Double  '定义起始角度,终止角度
    ' N: n1 O% t6 r: V* {1 o5 C
  6.     Dim str As Double, edr As Double  '定义起始弧度,终止弧度
    5 D7 ^! U7 m# C; y
  7.     Const pi = 3.14159265358979         '定义π常量,只能保留15位有效数字
    3 b, f5 s5 W% r% j4 q' n5 e
  8.     Dim n%5 ]: P' a+ _' @# A! ]/ d
  9.     pot(1) = 0: pot(2) = 0: pot(3) = 0. d7 B. C/ E4 n1 E. F# R6 V# j( Y
  10.     For n = 1 To 10
    * s! Q) }- i0 a0 M$ V& [3 o
  11.         R = 39.5629 + (n - 1) * 100 |9 w' T, H  i& y2 K
  12.         stq = 0 + (n - 1) * 10" J; b# t7 b( u; `
  13.         edq = 60 + (n - 1) * 106 C$ C( k* Q- a6 D0 {8 S5 u: [0 L
  14.         Rem 如下度数转换为弧度值% c# ?, q, b; }/ Q9 h9 C2 a
  15.         str = stq * pi / 180" D% U: r3 _' n- B. E; V& v1 K) a. X
  16.         edr = edq * pi / 180+ [; Y& v) p0 r- W
  17.         Rem 接下来画圆弧
    9 r- R  o2 y9 Z/ T, |' f2 m
  18.         Set arc = ThisDrawing.ModelSpace.AddArc(pot, R, str, edr)   '画的是逆时针圆弧
    , M; B. h. K! z& Z9 v( J% u
  19.         Update
    * w6 X; [0 Y" V6 x! X4 m
  20.         Set arc = ThisDrawing.ModelSpace.AddArc(pot, R, edr, str)   '画的还是逆时针圆弧' ?( x7 q+ \$ U+ N
  21.         Update! D* P3 z1 x1 I! m$ e+ |6 O) \
  22.     Next
    : D2 \) [  T3 F# c4 T
  23.     For n = 1 To 10- |1 T* N0 I$ G; b* i8 `0 l. L
  24.         pot(1) = 200: pot(2) = 200
    8 z) q7 Q  d/ M3 k; t9 H( `$ s
  25.         R = 100 + (n - 1) * 10, ~7 c7 p( p2 V, Q8 s
  26.         str = (0 + (n - 1) * 10) * pi / 1800 i7 w+ T$ f5 e, e9 x
  27.         edr = (-60 - (n - 1) * 10) * pi / 180
    0 n% ?$ g/ A3 K; |' y# B
  28.         ThisDrawing.ModelSpace.AddArc pot, R, str, edr       '画的还是逆时针圆弧
    8 K  r9 z2 k, w: X% b; m
  29.         Update
    & o6 l2 j9 P  c3 y6 K: B: i% U6 x
  30.     Next) y/ F! M- ^# S8 k# |
  31. End Sub
复制代码
% f' O% N& _" H% L4 Z2 f

/ _0 o' \7 a* S! w3 m. iB、根据三点画弧
首先需要根据三点坐标换算出圆心坐标,半径大小,起始角度,终止角度.然后使用A方法画圆弧即可.
  1. Sub 三点画弧()
    2 k" q& u3 W! D1 c( @
  2.     Dim ARC As AcadArc
    & R$ o0 _! \' T& B% W  y+ p7 E
  3.     Dim pt1(2) As Double, pt2(2) As Double, pt3(2) As Double5 U, U5 n# x% }; z5 K& z4 ?
  4.     Dim A1#, B1#, C1#, A2#, B2#, C2#                   '定义中间变量为double类型,用于简化计算
    * Y, R6 p( ^3 P2 k; B
  5.     Dim pt0(2) As Double, r#                          '定义圆心坐标(X,Y)和半径r0 B) N9 C) _$ U- q; @
  6.     Dim fst As Double, enr As Double                  '定义起始角和终止角
    8 j( v! ]+ N9 x9 Z3 v3 e" f/ i
  7.     Const pi As Double = 3.14159265358979              '定义π常量: c7 f" G2 ]& P) q% m9 w
  8.     pt1(0) = 120: pt1(1) = 105                         '第一点坐标(X1,Y1),作为圆弧的起始角点
    * i" b: o" @" H" O$ s
  9.     pt2(0) = 59: pt2(1) = 67                           '第二点坐标(X2,Y2),作为圆弧的终止角点1 N1 o7 F# J4 h# N* \2 g2 X& V0 P
  10.     pt3(0) = 89: pt3(1) = 91                           '第三点坐标(X3,Y3)
    $ o# p/ [  v0 d# T% I8 c: p
  11.     A1 = 2 * (pt2(0) - pt1(0))                          'A1=2*(X2-X1)' V6 F- C7 ^+ H+ b  x" w
  12.     B1 = 2 * (pt2(1) - pt1(1))                          'B1=2*(Y2-Y1)
    ! i2 ~# q  o/ g7 Y  X2 c( m5 x# j
  13.     C1 = pt2(0) ^ 2 - pt1(0) ^ 2 + pt2(1) ^ 2 - pt1(1) ^ 2     'C1=X2^2-X1^2+Y2^2-Y1^2$ n$ q6 `& o1 j3 k# r8 L# z
  14.     A2 = 2 * (pt3(0) - pt1(0))                          'A2=2*(X3-X1)( _9 y/ Z) x- `1 O( r$ N4 q
  15.     B2 = 2 * (pt3(1) - pt1(1))                          'B2=2*(Y3-Y1)5 y2 T, f3 P- K* [- F% E  I
  16.     C2 = pt3(0) ^ 2 - pt1(0) ^ 2 + pt3(1) ^ 2 - pt1(1) ^ 2     'C2=X3^2-X1^2+Y3^2-Y1^2" O: J" s/ t$ ^! [' P/ x
  17.     pt0(0) = (B1 * C2 - B2 * C1) / (A2 * B1 - A1 * B2)       'X=(B1*C2-B2*C1)/(A2*B1-A1*B2)  C2 b1 C" ~0 M9 W5 e* z
  18.     pt0(1) = (A2 * C1 - A1 * C2) / (A2 * B1 - A1 * B2)       'Y=(A2*C1-A1*C2)/(A2*B1-A1*B2)
    3 L: G1 e$ O' j* H$ T
  19.     r = ((pt0(0) - pt1(0)) ^ 2 + (pt0(1) - pt1(1)) ^ 2) ^ 0.5    'r=((X-X1)^2+(Y-Y1)^2)^0.5/ Z& n* m6 r* y! V; V2 }
  20.     fst = pi + Atn((pt1(1) - pt0(1)) / (pt1(0) - pt0(0)))       'VBA中只有反正切函数,没有反正弦和反余弦函数+ Y, L* U" p( ~0 Z0 n; w
  21.     enr = pi + Atn((pt2(1) - pt0(1)) / (pt2(0) - pt0(0)))      'Atn((Y3-Y0)/(X3-X0))结果就是终止角的弧度值  z$ _/ T8 a1 m3 {8 U
  22.    Rem 因为圆心在指定的三点的右下方,所以起始角和终止角均为负值,实际画圆弧的起始角和终止角均要加180°4 ?6 ?: ^8 k' s- }) e/ l
  23.     With ThisDrawing.ModelSpace, M8 S* M# h" }
  24.         .AddArc pt0, r, fst, enr      '添加圆弧
    ) r7 m4 d. _4 G, s) F& b$ c
  25.         .AddLine pt1, pt2   '画直线为了查看点在哪里/ q5 Z( o9 D. x/ n, T5 a
  26.         .AddLine pt2, pt3
    * L3 I+ s9 W# y
  27.     End With9 `) v0 B% U% J" @! ]" I7 o4 e# w
  28. End Sub
复制代码
$ H5 @4 Q+ M+ _0 [* F
关于起始角终止角的判定:首先VBA中只有反正切函数,没有反正弦、反余弦函数,所以只能借助反正切函数求角度,自然就会出现90°/270°不能根据反正切求出的破绽。
所以需要事先判断起始角和终止角是否为90°/270°,方法是圆心横坐标起点或终点的横坐标是否相同,圆心纵坐标与起点或终点纵坐标谁大?前者相同时,圆心纵坐标小则为90°,圆心纵坐标大则为270°;不同就不是90°/270°。
    另外就是根据反正切求出的角度有时需要加π,根据几何图形可知:起点坐标相对于圆心坐标在第一象限或者第四象限时直接使用反正切的结果;相对在第二象限或第三象限时使用π+反正切
直接判断横坐标:起点或终点横坐标大于圆心横坐标,则在第一或第四象限;起点或终点横坐标小于圆心横坐标,则在第二或第三象限。
所以修改后的代码如下:
  1. Sub 三点画弧()" _" F- J1 w% |
  2.     Dim ARC As AcadArc
    ( M9 s8 V, C6 F0 {! _0 T! v
  3.     Dim pt1(2) As Double, pt2(2) As Double, pt3(2) As Double
    4 w2 X  U7 }* V" G8 h% u' m
  4.     Dim A1#, B1#, C1#, A2#, B2#, C2#                       '定义中间变量为double类型,用于简化计算' M4 c* y6 b! O
  5.     Dim pt0(2) As Double, R#                                       '定义圆心坐标(X,Y)和半径r# t% B- t+ ^! z; @2 I0 p2 M
  6.     Dim fst As Double, enr As Double                               '定义起始角和终止角
    6 T: _8 T! \* H
  7.     Const pi As Double = 3.14159265358979                          '定义π常量
      m( u. d' c" A! q! k8 |. _  G0 |
  8.     pt1(0) = 120: pt1(1) = 105                               '第一点坐标(X1,Y1),作为圆弧的起始角点
    4 O8 z3 ^+ \: C" c
  9.     pt2(0) = 59: pt2(1) = 67                                 '第二点坐标(X2,Y2),作为圆弧的终止角点( V6 I( T9 |& O& D9 y4 k% c5 I1 C3 T
  10.     pt3(0) = 89: pt3(1) = 91                                       '第三点坐标(X3,Y3)
    5 J, U4 e1 k1 p# u
  11.     A1 = 2 * (pt2(0) - pt1(0))                                     'A1=2*(X2-X1)+ h3 v5 o4 f' A4 J7 f+ T
  12.     B1 = 2 * (pt2(1) - pt1(1))                                     'B1=2*(Y2-Y1)
    ! g* x$ Y7 S4 \8 U
  13.     C1 = pt2(0) ^ 2 - pt1(0) ^ 2 + pt2(1) ^ 2 - pt1(1) ^ 2         'C1=X2^2-X1^2+Y2^2-Y1^2
    2 a& i' B; x& P
  14.     A2 = 2 * (pt3(0) - pt1(0))                                     'A2=2*(X3-X1)
    6 }0 g$ Z. w( I4 g% _$ ^
  15.     B2 = 2 * (pt3(1) - pt1(1))                                     'B2=2*(Y3-Y1)+ p4 Z7 A! V/ M; d
  16.     C2 = pt3(0) ^ 2 - pt1(0) ^ 2 + pt3(1) ^ 2 - pt1(1) ^ 2         'C2=X3^2-X1^2+Y3^2-Y1^2
    & m! t2 b/ ^9 B5 N! J6 @% d" n
  17.     pt0(0) = (B1 * C2 - B2 * C1) / (A2 * B1 - A1 * B2)             'X=(B1*C2-B2*C1)/(A2*B1-A1*B2)
    4 k5 j$ T) I9 k9 X: a: I
  18.     pt0(1) = (A2 * C1 - A1 * C2) / (A2 * B1 - A1 * B2)             'Y=(A2*C1-A1*C2)/(A2*B1-A1*B2)
    ( P! l- ~8 h  L$ G& T* H: r4 s
  19.     R = ((pt0(0) - pt1(0)) ^ 2 + (pt0(1) - pt1(1)) ^ 2) ^ 0.5      'r=((X-X1)^2+(Y-Y1)^2)^0.59 X; r* p, l: i
  20.     If pt1(0) > pt0(0) Then# D. k; l+ T# g
  21.         fst = Atn((pt1(1) - pt0(1)) / (pt1(0) - pt0(0)))
    4 v# f  ]( y3 [( [/ o( d
  22.     ElseIf pt1(0) < pt0(0) Then
      v* [" q& f' S3 H
  23.         fst = pi + Atn((pt1(1) - pt0(1)) / (pt1(0) - pt0(0)))   'VBA中只有反正切函数,没有反正弦和反余弦函数$ ^# I3 [4 J9 u  q% f& Y
  24.     Else3 ^* W9 y. v) h: P0 [4 [
  25.         If pt1(1) > pt0(1) Then
    " g8 w2 ^$ _/ L2 a( ]* z! S$ |
  26.             fst = pi / 2; `' z1 K  r8 ]! ^
  27.         Else
    + }( R3 B; y5 o
  28.             fst = 3 * pi / 2, W9 B- q- F2 B- u. ?
  29.         End If
    2 ?  X' m- t# c
  30.     End If
    $ u' {  B! l. @( o+ i+ s
  31.     If pt2(0) > pt0(0) Then0 v# j. u7 o( n3 u  {3 U5 n
  32.         enr = Atn((pt2(1) - pt0(1)) / (pt2(0) - pt0(0)))
    0 j" z6 c# j5 ^0 Y4 T2 S
  33.     ElseIf pt2(0) < pt0(0) Then5 I  m; ?9 t! D
  34.         enr = pi + Atn((pt2(1) - pt0(1)) / (pt2(0) - pt0(0)))   'Atn((Y3-Y0)/(X3-X0))结果就是终止角的弧度值# ?$ J1 n0 }$ z( v9 q1 V' H
  35.     Else/ ]7 {; |& `+ A# S! {7 K7 ~( s
  36.         If pt2(1) > pt0(1) Then1 t7 ]/ c0 G$ q- A( m3 H2 ]: C
  37.             enr = pi / 2
    6 U# |* r/ T. W
  38.         Else
    , Z3 W. k( W' B5 X
  39.             enr = 3 * pi / 2: T! j4 v  A# F
  40.         End If
    - X/ w2 ~5 ?' O1 B( h3 Q
  41.     End If- V' }8 E( C- B8 u8 j
  42.     With ThisDrawing.ModelSpace
    ( Q4 b% i" a" C3 P
  43.         .AddArc pt0, R, fst, enr                                '添加圆弧
    / S5 O/ y5 w. ?0 ?$ t8 _
  44.         .AddLine pt1, pt2                                       '画直线为了查看点在哪里
    / ~' y8 f2 o! D. k4 f9 y0 e
  45.         .AddLine pt2, pt3  {! k3 [3 V0 I' B
  46.     End With
    $ r9 m7 D) c; I! t- H6 N* @
  47. End Sub
复制代码
' i% }  }) M& U

# ]" W, U& _7 {8 Z6 f0 E3 H. e* K6 G  j
2 p- ^% J0 c4 @

6 _7 X! A) x6 i3 I( x5 E
 楼主| 发表于 2019-3-25 21:23:31 | 显示全部楼层
C、起点、端点、半径画弧
根据起点和端点及半径计算出圆心坐标,进而计算出起始角和终止角
已知:点A(X1,Y1)、点B(X2,Y2)、半径R,求圆心坐标O(X0,Y0)
理论计算如下: AB>2R时无解;AB=2R时有1解,圆心在AB中点处;AB<2R时有2解。
1553519917(1).jpg
/ d" c' M" B3 z/ r& Q0 k

1 w: n3 p5 p+ t8 _5 R* _
                              
  1. Sub 起端半径画弧()
    # z" O$ {  N) G- p/ ^* b- ]
  2.     Rem 根据理论计算方法画弧,假设AB和OM斜率均存在的情况下。
    9 g" Q- P; r" G3 V5 G
  3.     Dim pt1(2) As Double, pt2(2) As Double, R As Double          '定义已知条件:起点A、端点B、半径R4 W" i9 S4 }. p: F
  4.     Dim pt3(2) As Double, pt01(2) As Double, pt02(2) As Double    '定义辅助点(AB中点M)、圆心点O(有2个圆心)
    0 D6 G2 a& Q2 q" q! S
  5.     Dim KAB As Double, KOM As Double                       '定义直线AB斜率KAB、直线OM斜率KOM
    ; G5 w: f* w' `) \5 v. f- ]1 {% J
  6.     Dim BM As Double                                     '定义BM长度
    ( h% G' {3 M6 B: t$ i
  7.     Dim QSJ As Double, ZZJ As Double                         '定义起始角,终止角
      a# Y. |: a& K
  8.     Const pi As Double = 3.14159265358979                   '定义常量π# s3 V, O* y% h) {5 l
  9.     pt1(0) = 32.59: pt1(1) = 36.98                            '已知点A坐标7 u+ @7 H' ~+ W# n
  10.     pt2(0) = 69.87: pt2(1) = 70.59                            '已知点B坐标2 ~. p" t/ L  F
  11.     ThisDrawing.ModelSpace.AddLine pt1, pt2                 '画线段AB
    ( U# t9 V, F$ ~! E2 p! m
  12.     Update
    9 @  @, o5 @; @' d
  13.     R = 100                                              '已知条件R
    * V+ r, W5 }8 ~, e" Y
  14.     pt3(0) = (pt1(0) + pt2(0)) / 2: pt3(1) = (pt1(1) + pt2(1)) / 2      '求出中点M坐标
    * z3 v! _; d7 m9 v- [: [$ m" x5 \
  15.     BM = Sqr((pt2(1) - pt3(1)) ^ 2 + (pt2(0) - pt3(0)) ^ 2)           '计算BM长度) V7 [; ?7 F7 o, M4 e% _2 K9 b
  16.     KAB = (pt2(1) - pt1(1)) / (pt2(0) - pt1(0))9 h; [2 C9 l" q
  17.     KOM = -1 / KAB
    ( g% N$ v1 m0 e5 c1 P& w8 h# U+ y" J
  18.     pt01(0) = pt3(0) + Sqr((R ^ 2 - BM ^ 2) / (KOM ^ 2 + 1))         '第一组圆心坐标X0
    1 ~+ w0 M# Y0 I: }; d# b8 _
  19.     pt01(1) = pt3(1) + KOM * Sqr((R ^ 2 - BM ^ 2) / (KOM ^ 2 + 1))   '第一组圆心坐标Y0
    $ `+ ~8 D# r6 l
  20.     pt02(0) = pt3(0) - Sqr((R ^ 2 - BM ^ 2) / (KOM ^ 2 + 1))         '第二组圆心坐标X0
    8 o5 h) y$ i- z0 R; g2 f3 i
  21.     pt02(1) = pt3(1) - KOM * Sqr((R ^ 2 - BM ^ 2) / (KOM ^ 2 + 1))   '第二组圆心坐标Y0# t3 }3 s; ?4 ?1 c7 `% k
  22.     Rem 计算起始角和终止角时需根据点坐标关系判断谁是起点和终点,以及想画的是优弧还是劣弧3 [1 U: c. L, X% H. v# H& _; r; Y8 R# m5 R
  23.     If pt2(0) > pt01(0) Then
      A* {, ]" }6 U# J: U* }
  24.         QSJ = Atn((pt2(1) - pt01(1)) / (pt2(0) - pt01(0)))
    3 \9 T) r5 v1 T% c! s" C
  25.     ElseIf pt2(0) < pt01(0) Then# H+ y- n* Y1 R
  26.         QSJ = pi + Atn((pt2(1) - pt01(1)) / (pt2(0) - pt01(0)))
    9 `' |$ N5 _% l& o0 J4 m+ h
  27.     Else
    ' @: K3 v& [. c: y+ b2 a0 L/ u
  28.         If pt2(1) > pt01(1) Then5 ^" x' P& b  E5 b" y% V
  29.             QSJ = pi / 2
    ) A* {6 h/ U  V3 m4 ~' F
  30.         Else
    4 }! V) W7 M/ L/ W
  31.             QSJ = 3 * pi / 2
    ; d3 H9 I, s9 u0 {
  32.         End If
    % _/ Q& ]/ P; m6 f& d- Z
  33.     End If
    - `! @  W, o* D, I/ I3 j+ o
  34.     If pt1(0) > pt01(0) Then
    " Y9 Q" ?% Q- V3 z. z& ~
  35.         ZZJ = Atn((pt1(1) - pt01(1)) / (pt1(0) - pt01(0)))( u9 g1 W: X0 S; J% b$ `. C) W
  36.     ElseIf pt1(0) < pt01(0) Then) p' P# V1 _' H" O5 {
  37.         ZZJ = pi + Atn((pt1(1) - pt01(1)) / (pt1(0) - pt01(0)))2 z0 b4 g' I' p  M2 W
  38.     Else
    4 t' f0 K. h/ P! m1 ^7 E9 x+ r
  39.         If pt1(1) > pt01(1) Then3 @% C9 U" _$ F% N, T9 ^3 e
  40.             ZZJ = pi / 2% L3 V1 o' c& u# j$ S4 ?: ?
  41.         Else7 _5 q* J! Y1 D$ \3 m
  42.             ZZJ = 3 * pi / 21 A; U) x8 i& ~( b# S5 k7 Q9 e
  43.         End If
    ' |! j* [2 [. I  E8 f, P& M, r0 _
  44.     End If( z/ o$ t/ S4 s0 J: t, p
  45.     ThisDrawing.ModelSpace.AddArc pt01, R, QSJ, ZZJ+ j& y, f% K; y! k
  46.     Update4 J/ s$ ]& ?  V$ o7 ^' q
  47.     If pt1(0) > pt02(0) Then
    6 c5 D/ ~- y. F+ N8 a
  48.         QSJ = Atn((pt1(1) - pt02(1)) / (pt1(0) - pt02(0)))  c: `% Y* i' i- w9 _
  49.     ElseIf pt1(0) < pt02(0) Then1 S/ A: j7 Z& L- \, u
  50.         QSJ = pi + Atn((pt1(1) - pt02(1)) / (pt1(0) - pt02(0)))
    2 M; Q" n6 U; b7 K* F
  51.     Else7 b* I/ d( n; O/ L! P& k) b
  52.         If pt1(1) > pt02(1) Then. v; }# ]2 G' t8 Y/ H4 @" Q
  53.             QSJ = pi / 2  s: n! N: W1 v$ n  x- j4 Y4 H
  54.         Else; R4 o+ @# h; K5 G
  55.             QSJ = 3 * pi / 2
    0 ?' {* O( E, R; E
  56.         End If
    ) C. H& ]/ @& {1 Q5 J* I! n3 |
  57.     End If
    5 e, a) L% x( Q7 M' T# }* y1 j; w
  58.     If pt2(0) > pt02(0) Then3 q5 k+ W- V9 X* C) K3 c
  59.         ZZJ = Atn((pt2(1) - pt02(1)) / (pt2(0) - pt02(0)))
      U# n! G4 u9 e! A# S( g
  60.     ElseIf pt2(0) < pt02(0) Then
    ; V2 z# H5 j! f0 b
  61.         ZZJ = pi + Atn((pt2(1) - pt02(1)) / (pt2(0) - pt02(0)))
    1 i* ]8 ]$ T/ Z! f
  62.     Else
    $ {$ y3 L' [' n6 p- \! \4 }
  63.         If pt2(1) > pt02(1) Then
    + \. t1 w; X- B  o5 f
  64.             ZZJ = pi / 2
    # f, J" r  {* p8 z
  65.         Else' h4 Z5 B! N9 `4 n
  66.             ZZJ = 3 * pi / 2' u. D$ S; I- }* D, ]
  67.         End If3 e" E4 x0 M' }  v+ O4 S
  68.     End If
    4 |5 o. t2 A) V% u+ e* B
  69.     QSJ = Atn((pt1(1) - pt02(1)) / (pt1(0) - pt02(0)))
    ) v6 Y$ b; v  v* k- ^( P
  70.     ZZJ = Atn((pt2(1) - pt02(1)) / (pt2(0) - pt02(0)))) K8 H7 e. O7 D; I- c% w
  71.     ThisDrawing.ModelSpace.AddArc pt02, R, QSJ, ZZJ   '画劣弧
    4 z% H1 w$ X$ F' {- G* [
  72.     Update, c- l7 G" `3 F' R" \4 \- |2 l
  73.     ThisDrawing.ModelSpace.AddArc pt02, R, ZZJ, QSJ   '画优弧
    ' S/ L" z, l7 u# I
  74.     Update: U6 U# g$ n0 f7 }0 d+ ]) |" }, K. Q
  75. End Sub
复制代码
2.4、圆弧命令.zip (11.43 KB, 下载次数: 2)
 楼主| 发表于 2019-3-25 21:32:37 | 显示全部楼层
5、对象操作方法之偏移、镜像! C. M( q( R6 E' i2 L- q

- r% {- e- Y% m1 B! V7 mAObject.Offset方法
在AutoCAD中,对象偏移的结果仍是对象,但是与Excel不同的是,在AutoCAD中对于很多对象,该操作的结果形成单一的新曲线(它的类型可能与原始曲线不同)。例如,椭圆偏移后的对象将会是样条曲线,这是因为结果不能与椭圆的方程式匹配。有时偏移结果可能形成多个曲线。
所以AutoCAD中偏移的结果是一个对象组成的数组
基本语法:RetVal = object.Offset(Distance)
Object可以是圆、圆弧、直线、多段线、样条曲线、构造线等对象。
Distance是偏移的距离(double双精度型),可以是正值或负值,但是不能为0。如果偏移为负值,这意味着将得到更“小”的曲线 (例如,一个圆以负值偏移后的得到的圆的半径将会比原对象半径小). 如果“小”没有意义,则AutoCAD将向小的XYZ WCS坐标方向偏移。如果偏移距离无效,则返回错误。
[明经通道特别提示对于的LightweightPolyline Polyline 对象,曲线有顺时针方向和逆时针方向,对于顺时针方向,距离值为正值时为向内偏移,距离值为负值时为向外偏移。对于逆时针时刚好相反。对于自相交的多段线的偏移方向需要自己慢慢实践了。
RetVal返回偏移的结果,注意是一个对象数组,所以在赋值时不用set,并且对赋予的新变量后续操作时,需用索引号选取第几个对象,一般用(0)来选取第一个。
  1. Sub 偏移()
    2 W8 b: X! D. O5 e
  2.     Dim l As AcadLWPolyline
      Q7 }# u6 Q$ d. U/ [$ ^3 U
  3.     Dim pot(5) As Double) s! W4 V" s' \' O8 r
  4.     Dim LL, l02  '直接定义为变体型类型,
    / @& I6 U2 U' b# G+ s, `
  5.     pot(0) = 50: pot(1) = 100) s" ~# V4 {" ~3 M% t
  6.     pot(2) = 300: pot(3) = 500% _7 L) l7 T, B( B$ }
  7.     pot(4) = 600: pot(5) = 190. Z! I) s0 a% m4 U1 k) w$ z
  8.     Set l = ThisDrawing.ModelSpace.AddLightWeightPolyline(pot)  '顺时针多段线" {6 G9 V7 q' B6 w5 n; }) L( Y; I
  9.     LL = l.Offset(35.26)            '正值向内偏移
    $ H$ z: @2 R) a" R# y0 Q( o
  10.     LL(0).Lineweight = acLnWt050   '设置线宽为0.50mm,用索引号(0)选取第一个对象元素
    / p; O' _" D4 K& R
  11.     l02 = l.Offset(-36.28)           '负值向外偏移7 i2 }7 d0 P  G+ {5 I& B$ P, Z; d
  12.     '.....................................................................
    , F7 K8 {; J; G5 H: Z  Y# H1 W

  13. / f$ Y8 Y% @1 N1 \" H
  14.     Dim l1 As AcadLWPolyline1 B8 s/ ?% w5 x4 P: M' t
  15.     Dim pot2(5) As Double
    ! }- H# N' o( p# I2 V* _( T2 W
  16.     Dim lll, lll02                   '定义变体型; D' Z; D: _* Q5 C0 I
  17.     pot2(0) = 10: pot2(1) = 10- `# p; l' A3 H- ?1 ?- p% E; [
  18.     pot2(2) = 100: pot2(3) = -3001 Q" ?8 M$ S5 ~: J( O- O1 M
  19.     pot2(4) = 300: pot2(5) = 5003 G4 @3 I) }6 j6 w; s: c
  20.     Set l1 = ThisDrawing.ModelSpace.AddLightWeightPolyline(pot2)   '逆时针多段线0 d- ]2 K+ w, Y, e
  21.     lll = l1.Offset(100)               '正值向外偏移' i& T; q% r* I! Z0 \
  22.     lll(0).Lineweight = acLnWt050     '设置线宽为0.50mm2 `6 z1 n' E0 W( e5 o
  23. lll02 = l1.Offset(-100)            '负值向内偏移,且结果变成一条线了!
    ( W0 l. h! U( x- G2 @+ @/ V
  24. l1.Offset 300                   '直接偏移. \, ~0 _* o, \0 h
  25. End Sub
复制代码

, E; ^* q3 I5 D% k/ q
& N. t; F4 J' i- T2 @) ~- F8 j' f9 w" ^6 ^0 [
通过以上程序感受一下对象偏移的结果及引用偏移的结果对象的方法。
3 B$ s# H- n7 K- q7 l; E$ _
, j. S" j* X- j! R7 h/ Y1 ^
 楼主| 发表于 2019-3-25 21:38:36 | 显示全部楼层
BObject.Mirror方法
镜像方法相对简单,结果就是一个新的对象。
语法:RetVal =Object.Mirror(Point1, Point2)
Object可以是任何图形对象;
Point1, Point2是镜像对称轴上两点的坐标,均为double类型。
RetVal是镜像后的对应对象
注意:可以使用 MIRRTEXT系统变量来管理文本对象的反向属性。MIRRTEXT 的缺省设置为开(1),它使文本对象与其它对象一样镜像。当其设置为关(0)时,文本不被镜像———AddMText方法讲解。
如果是想同时镜像多个对象,可以先将多个对象建立成块,然后镜像块即可。
  1. Sub 镜像()7 g5 X4 o3 G" D& m6 X3 G' `
  2.     Dim pl As AcadLWPolyline
    4 b' r  }, i* {% Y9 M5 \
  3.     Dim pts(9) As Double+ K+ c2 O6 A! ~  P& n
  4.     Dim pl2 As AcadLWPolyline
    - G& x1 B- a# U- H4 h$ X; O; [9 ]% H
  5.     Dim pt01(2) As Double, pt02(2) As Double, pt03(2) As Double! ~" u1 F8 C$ `( h& z1 o. j
  6.     Dim rec As Object
    : \( I# X: Z- @7 i
  7.     pts(0) = 0: pts(1) = 0
    6 L7 G: x; S4 A5 u) V
  8.     pts(2) = 100: pts(3) = 0
    ) i2 Y5 R" |% A
  9.     pts(4) = 100: pts(5) = 100$ Q% `2 P1 Y- f
  10.     pts(6) = 0: pts(7) = 100+ a# Z4 V0 d6 q3 w# ?
  11.     pts(8) = 0: pts(9) = 0
    3 l% j: W- q. \- E
  12.     Set pl = ThisDrawing.ModelSpace.AddLightWeightPolyline(pts) '绘制多段线矩形
    1 q: [5 E7 Z& n" p7 G  [, [
  13.     pt01(0) = 0: pt01(1) = 150$ Q4 ?; X. g' Y: ^* r+ h, s
  14.     pt02(0) = 150: pt02(1) = 150
    1 Z8 _: w' S" P7 l
  15.     pt03(0) = 150: pt03(1) = 0
    ) D5 V" N) l' H
  16.     With ThisDrawing.ModelSpace) s# Y3 m) w8 X% L
  17.         .AddLine pt01, pt022 i) E5 o: e5 c/ g; x9 y" y
  18.         .AddLine pt02, pt03
    2 k. C$ A1 i; `) @# w/ j
  19.     End With
    8 o- S4 s  c/ u* {
  20.     Set rec = pl.Mirror(pt01, pt02)   '给矩形镜像并赋给新对象" j+ P7 M  T! M" r7 u1 b1 z$ W- I
  21.     pl.Mirror pt02, pt03              '直接镜像
    ; o% n: s- e) p9 G# ?
  22. End Sub
复制代码
2.5、偏移、镜像.zip (4.58 KB, 下载次数: 2)
 楼主| 发表于 2019-3-25 21:48:57 | 显示全部楼层
本帖最后由 kuangben8 于 2019-3-25 22:04 编辑 & d. o$ N3 q! {  M0 L* @, F, \
; g7 h9 p' |- `% k
6、设置对象属性之颜色、线宽、线型、比例、图层
& E4 m* }6 ]; I* v  _

8 C8 H; @' r8 a& a$ U+ G# T* SA、添加线型
  1. Sub 添加线型()
    , j7 d% n8 b5 [  a6 e
  2.     ' 该示例尝试从acad.lin文件中加载 "CENTER" 线型。如果该线型已经存在,则提示错误。
    6 J5 }  {$ a; ~- k1 K  F1 I4 L3 ^
  3.     Dim L As AcadLine, P1(2) As Double, P2(2) As Double# T2 B* M% q; y
  4.     ' 从acad.lin文件中加载 "CENTER"线型" I; v( q9 F; \6 V% L
  5.     On Error Resume Next    ' 下面添加线型语句在已经添加了线型时会出错!所以添加此句% v9 L& }( x) w. m8 w
  6.     ThisDrawing.Linetypes.Load "CENTER", "acad.lin"   ‘加载线型
    ( N! U& C2 e" v
  7.     On Error GoTo 0    '恢复错误提示
    5 M8 u. T2 m' Q" U, E6 e
  8.     MsgBox Err.Number   '弹出错误对应的数字代码,此处没啥用,就是看看错误对应的代码。
    2 e0 s* A* H  m- V
  9.     Err.Clear     '清除错误
    , I. i( |: m+ L: a# D2 z( y) x: E$ ^! v
  10.     P1(0) = 0: P1(1) = 0
      s9 r4 o9 I* L
  11.     P2(0) = 100: P2(1) = 100
    4 r8 F  L# O) z0 c; e
  12.     Set L = ThisDrawing.ModelSpace.AddLine(P1, P2)
    ( y0 I9 v/ B# i
  13.     L.Linetype = "CENTER"                           ‘设置对象的线型属性
    # k$ q6 y# Y: w, F4 Y! \
  14. End Sub
复制代码

! M4 d/ S& Q6 ]6 M* M) Y% H" u; Q& `1 E3 l' K) X
B、设置对象属性之颜色
在AutoCAD中设置对象颜色有两种方法:Color属性(早起版本,后续会被淘汰)、AcadAcCmColor对象(AutoCAD真彩色对象)。
  1. Sub 颜色属性()3 r* `6 y- ?7 i$ T: A( P  m. d
  2.     Dim L As AcadLine, P1(2) As Double, P2(2) As Double- R. |) [2 T+ h' b) `
  3.     '    Dim CL As AcadAcCmColor9 Y" i4 A, ?$ H
  4.     On Error Resume Next3 A' O9 ]4 O; T+ O/ `* D3 ]
  5.     ThisDrawing.Linetypes.Load "DASHDOT", "acad.lin"
    ( |+ z5 {* f9 v* x8 l( a/ F8 u9 o
  6.     '先加载线型,如果已存在,会报错,所以添加上面容错语句
    $ ~9 P* m( V% p9 G; L/ `& E$ e
  7.     Rem dashdot是线型的名字,加载中心线就是CENTER,Acad.lin类似CAD存储线型的文件夹
    8 J; V2 a7 T! x; e# e* s
  8.     On Error GoTo 0
    : x0 E$ C1 l0 U- E9 x
  9.     Err.Clear    '清除错误!- I9 R9 g9 `, i/ w
  10.     '    Set CL = New AcadAcCmColor
    , H# V4 z1 o) J6 |. Q  I6 J. S5 W
  11.     '    CL.ColorIndex = acRed
    ' |% H' Y+ S3 w* {. Y1 ]
  12.     P2(0) = 100: P2(1) = 100
    9 z: I3 O& i; S1 f# M3 d
  13.     Set L = ThisDrawing.ModelSpace.AddLine(P1, P2)
    8 m" B  `' r' t1 v$ S$ R8 Z
  14.     L.Linetype = "DASHDOT"8 t( S# @$ T  {) \1 z
  15.     '    L.TrueColor = CL$ n5 K% q9 S% w
  16.     L.color = acCyan   '藏青色: J7 Y) x/ l2 B7 `
  17.     '    L.color = RGB(213, 222, 198)  '使用RGB函数赋值颜色无效!
    ; @$ [+ U/ f4 o0 H" P5 J
  18. End Sub
复制代码

: W9 E  D9 s& F
( L' |' u* W( m7 K( v, g9 f$ ?0 \1 _  `* q, v: f- t2 I3 a/ Z: `
  1. Sub 颜色对象()
    $ J5 K/ Q: _& s: y& L+ E: m
  2.     Dim L As AcadLine, P1(2) As Double, P2(2) As Double* ?" n9 d" u: J2 g
  3.     Dim CL As Object   'AcadAcCmColor  定义为对象或者制定的颜色对象均可。" P$ _: j; F, E6 Y" u  M
  4.     Dim n1 r4 h+ I  ?2 V& u6 g! s1 b
  5.     On Error Resume Next+ Z+ h0 C& o- t* H! L4 x
  6.     '如果线型已加载,使用下面这行加载线型的语句就会引发错误。所以这行用错误处理语句跳过可能的错误,这样在重复使用这段程序时就不会带来不必要麻烦——不用先检查线型是否已加载
    - }  S" \1 P0 F' P
  7.     ThisDrawing.Linetypes.Load "DASHDOT", "acad.lin"; u) x" u" `, t
  8.     On Error GoTo 0 '这行是恢复正常报错,以免后面调试时出了错不报
    ; v- [2 R. m6 J
  9.     Err.Clear '和上面这行一样用处,清除错误$ B& z) p# H1 p$ \/ z1 E
  10. '    Set CL = New AcadAcCmColor( |( F0 @6 e  u) t) L
  11.     Rem 上面语句相当于新建一个颜色对象,也可以使用AcadApplication.GetInterfaceObject("AutoCAD.AcCmColor.版本号")来创建颜色对象  n  s% i- T' `$ @! E* O6 i& I: A" k! v
  12.     n = Application.Version   '查看当前CAD版本号4 W$ ~/ {1 [4 q1 h: N4 b  l( |" F
  13.     Set CL = GetInterfaceObject("AutoCAD.AcCmColor.19")   '19就是上一句获得的结果9 A6 G+ Y. q4 q+ N# `0 R
  14.     CL.ColorIndex = acRed   '可以使用颜色索引号索取颜色' p8 d/ A& V) I" d: Z
  15. '   CL.color = RGB(200, 215, 225)  '同样不能使用RGB函数赋值颜色5 _3 k% ~) Z' s9 w2 ]
  16.     Call CL.SetRGB(200, 215, 225)      '也可以使用SetRGB方法指定对应颜色,不用call时,参数的括号不要写。% L' B( S9 D8 d! a6 S* D1 F
  17.     P2(0) = 100: P2(1) = 100
    + Q; S4 M) e3 p# S" ]
  18.     Set L = ThisDrawing.ModelSpace.AddLine(P1, P2)) C4 A% C0 h$ C6 N  U- Q
  19.     L.Linetype = "DASHDOT"
    1 A, W* [# J& ^; }
  20.     L.TrueColor = CL- F: y8 S* R  O% G7 r
  21. End Sub
复制代码
5 w/ L* c% |! w; i- P* z
注意:AcadApplication对象的GetInterfaceObject 方法,是创建一个CAD程序的子对象,它在VBA中是没有加载的,用的时候新建就可以了。通过以上两例子来体会一下两种赋值颜色的语句的不同!( [% }% y9 t; Q* ?( B

" @5 S# V: g$ L# Q1 h6 a
 楼主| 发表于 2019-3-25 21:51:49 | 显示全部楼层
C、设置线宽和比例
  1. Sub 设置线宽和比例()5 x: w: C- @) \5 |! _
  2.     Dim L As AcadLine, P1(2) As Double, P2(2) As Double
    / v% G/ o8 V. T
  3.     Dim CL As AcadAcCmColor
    " f; \/ V3 z, X) |! q
  4.     On Error Resume Next
    # u8 n% O) y! e# _
  5.     ThisDrawing.Linetypes.Load "DASHDOT", "acad.lin"
    : G' u* ~  i4 g9 a7 c  }5 E
  6.     On Error GoTo 0 '这行是恢复正常报错,以免后面调试时出了错不报4 B7 \* H' I. x. e+ B: a; [) x3 h
  7.     Err.Clear '和上面这行一样用处,清除错误- p8 K  I9 Y; e. J# w
  8.     Set CL = New AcadAcCmColor
    & Q9 b# K# ^, Y% }5 c
  9.     CL.ColorIndex = acRed! G' r2 i$ A( u5 u
  10.     P2(0) = 100: P2(1) = 100' ^% Z- a( \5 f0 O$ p( I# x
  11.     Set L = ThisDrawing.ModelSpace.AddLine(P1, P2)6 M) W8 K3 S9 y4 d. i# Q9 p' d0 W
  12.     L.Linetype = "DASHDOT"
    . J/ O8 K6 t7 f8 E+ K: w& E
  13.     L.TrueColor = CL5 K6 r" V5 D- c: P" r
  14.     L.Lineweight = acLnWt050        '050代表0.50mm 粗( n4 G3 z% i. ?# Q& G! U
  15.     L.LinetypeScale = 2.25           '指定线型的比例因子,该值必须正实数,默认1.0/ n  _7 l; A* ^/ V
  16. End Sub
复制代码
& M9 J  s$ a4 m& I: J2 q
对象的一些基本属性相对简单,不在赘述!

. n9 v2 J7 p% z/ F7 m
; ^4 J4 K7 }- N% q
D、添加图层
  1. Sub 添加图层()* Y, L  h. I0 |  l* ?/ O1 U% j) `' p
  2.     Dim layerObj As AcadLayer   '定义图层对象变量
    6 h! L& l+ f  F- |" ^
  3.     Set layerObj = ThisDrawing.Layers.Add("ABC")   '创建新图层6 L4 k3 W+ |3 T& z) f4 M
  4.     Dim color As AcadAcCmColor                      '定义颜色对象变量. z) D3 D3 p& P) H5 S; I1 R6 H
  5.     Set color = AcadApplication.GetInterfaceObject("AutoCAD.AcCmColor.19")   '创建颜色对象  M9 F+ d1 B5 h8 ^# V: z6 C
  6.     Call color.SetRGB(80, 100, 244)    '设置颜色值(通过RGB值指定)
    % P  z& w$ b2 F, s; m3 ]4 v, I
  7.     layerObj.TrueColor = color         '设置图层颜色8 j! B8 x; Z$ Q2 c# l7 P: z, s
  8.     On Error Resume Next7 T* P: h. O8 a) u/ ]% E
  9.     ThisDrawing.Linetypes.Load "DIVIDE2", "acad.lin"- o' y5 [0 x& O, g' l
  10.     On Error GoTo 0 '这行是恢复正常报错,以免后面调试时出了错不报! Y) t. Q/ I' D
  11.     Err.Clear '和上面这行一样用处,清除错误
    , J7 X: b, Q% p: x* _" m
  12.     layerObj.Linetype = "DIVIDE2"       '设置图层的线型' Q$ `  ^& }# `8 e9 j/ e2 J+ N
  13.     layerObj.Lineweight = acLnWt040     '设置图层的线宽( B1 {9 ?5 Q8 B( X5 u! t
  14. '    layerObj.LinetypeScale = 2.5       '不支持设置线型比例方法. j% ^; r( M" n% w
  15.     Dim circleObj As AcadCircle        '定义圆变量
    6 v, j: k, C/ m) o! v/ E  ~) `
  16.     Dim center(0 To 2) As Double) L0 _3 p6 F. m( E+ W
  17.     Dim radius As Double$ @+ f- W1 U& Z' g) b- l
  18.     center(0) = 3: center(1) = 3: center(2) = 0
    8 O# R. v0 k% o" G: [; C
  19.     radius = 1.56 E0 R6 y$ r; F; i0 X' i. I
  20.     Set circleObj = ThisDrawing.ModelSpace.AddCircle(center, radius)    '画圆
    9 d. Y' O: x/ N! m  I9 c0 i
  21.     Update
    + s: W$ W" {6 w& B) w4 ~
  22.     MsgBox "已经在图层上创建了圆,对应图层是: " & circleObj.Layer, , "Layer 示例"" `( Q# T7 o. y+ K  Q4 f
  23.     Update
    1 Y2 j( v3 V! Y6 G
  24.     circleObj.Layer = "ABC"    '将圆所在图层设置为指定的图层- R- D7 O% Z/ C+ p- z
  25.     Update% `" U& i: e$ t; t5 o
  26.     ThisDrawing.Regen (True)     '重生成整个图形并重计算所有对象的屏幕坐标和显示精度。
    8 z" i- h2 x0 N. c. Z* E7 h. _) L
  27.     MsgBox "现在圆已经在" & circleObj.Layer & "图层上了!", , "Layer 示例"
    : C: P* _) R) z
  28. End Sub
复制代码
2.6、线型、颜色、线宽、比例、图层.zip (10.02 KB, 下载次数: 1)
 楼主| 发表于 2019-3-27 20:45:31 | 显示全部楼层
7、添加文字(AddMText)
该方法是在由插入点边框宽度所定义的矩形中创建多行文字。
语法:RetVal= object.AddMText(InsertionPoint, Width, Text)
Object针对ModelSpace 集合,PaperSpace 集合, Block等对象。
InsertionPointVariant[变体] (三元素双精度数组); 仅用于输入多行文字边框的插入点。
WidthDouble[双精度]; 仅用于输入多行文字边框的宽度(一行容纳字符数量的宽度)
TextString[字符串]; 仅用于输入MText 对象的实际文本字符串。
RetVal结果就是一个多行文本对象。示例如下:
  1. Sub Example_AddMtext()
    ; E9 c7 i2 ^. A; |3 P# y' [4 \
  2.     ' 该示例在模型空间中创建多行文字对象。
    $ Q1 ]6 \8 X$ B4 n1 f
  3.     Dim MTextObj As AcadMText# i  ]( b* }1 n2 _: b2 \( }
  4.     Dim corner(0 To 2) As Double
    & |1 W- u* _, y: m8 H5 R
  5.     Dim width As Double
    * }4 w' V' \5 X! R- k& Z  P
  6.     Dim text As String
    " _; M9 }! a- ]  c+ n) L
  7.     corner(0) = 0#: corner(1) = 10#: corner(2) = 0#% }8 `6 J6 J) G' y0 \( ^4 j
  8.     width = 20   '一行容纳文字数量的宽度) r5 J: w1 n$ B7 t; \/ T
  9.     text = "This is the text String for the mtext Object"2 M+ B' v( f+ M$ B
  10.     ' 创建多行文字对象2 h$ T  |+ j& `, ?( X
  11.     Set MTextObj = ThisDrawing.ModelSpace.AddMText(corner, width, text)" P' i) O4 X; y: F
  12. ZoomAll4 d& B1 V; p$ X! J+ z
  13. '.................................................................................................................& U) j9 H3 h: `9 r% {
  14.     Dim pt1(2) As Double, pt2(2) As Double
    ; z9 W' n1 z2 n8 Q3 x
  15.     Dim str As String
    ) M$ U& y7 E8 h3 |- B! ~
  16.     str = "mirrtext 1 "   '按照界面操作顺序输入/ x5 W) |" ~' H. m) |+ }0 I4 U; s
  17.     ThisDrawing.SendCommand str   '向命令行发送命令并自动执行
    0 H2 J7 W  Q$ [/ }
  18.     pt1(0) = 30: pt1(1) = -10
    8 o8 t! F+ m1 D
  19.     pt2(0) = 30: pt2(1) = 30* l& l) P! Z6 r7 J( ?( n
  20.     MTextObj.Mirror pt1, pt2& H& i3 r; `6 o; r0 ?3 q- e
  21.     ThisDrawing.SendCommand "mirrtext 0 "    '恢复文字不镜像,因为一般都不镜像
    % d. u( w. M& K7 q
  22. End Sub
复制代码

- k* M3 x5 R) R- Y) k
修改系统变量,除了类似界面操作外,在代码中改可以用 Document 对象的 SetVariable 方法。获取系统变量值用 GetVariable(有兴趣自己摸索一下:)。

/ L! K- m" C' ~, F' P0 x( k2 J
想要创建单行文本,可以使用AddText方法。
RetVal = object.AddText(实际显示文字的字符串,文字插入点三维坐标, 文字的高度)
需注意文字的高度必须是正数!mm为单位。
  1. Sub AddText方法()' f1 ]4 U" b& n% P3 y, ?
  2.     Dim textObj As AcadText6 J$ Z' @2 [! U1 R
  3.     Dim textString As String+ k% f) e+ ~  l8 T
  4.     Dim insertionPoint(0 To 2) As Double
    . ~3 B- Z" ]' Y5 J4 `" [( z( V
  5.     Dim height As Double8 [3 b9 j) t# ]7 `  W
  6.     ' 定义文字对象" W2 G, p, W& ~( h
  7.     textString = "我的AutoCAD文字"
    * X& u. Z* ^9 C' q  j- E2 R
  8.     insertionPoint(0) = 2: insertionPoint(1) = 2: insertionPoint(2) = 0
    5 p! C4 B& z9 z$ O3 p; M
  9.     height = 2.5    ‘2.5mm高
    / j! S: P* I+ c5 G$ J& F) ]0 a: `7 A
  10.     ' 在模型空间中创建文字对象
    % y: `0 O, C& z' y2 G) ]
  11.     Set textObj = ThisDrawing.ModelSpace.AddText(textString, insertionPoint, height)* h) I8 Y+ r0 B$ V) K: A9 u
  12.     Update8 r! Y. c9 Q% u" R
  13.     '............................................................0 ~% ~0 z( ]! u' l# w: U
  14.     Dim pt1(2) As Double, pt2(2) As Double: a3 F2 a& P: [# Z+ ~4 d
  15.     Dim str As String9 W5 g9 `# N6 ?7 ]
  16.     str = "mirrtext 1 "   '按照界面操作顺序输入3 i; N  l! S# m( @7 R/ _, J6 H8 L
  17.     ThisDrawing.SendCommand str   '向命令行发送命令并自动执行
    2 ?, g: e7 _# o& Q% Z/ a
  18.     pt1(0) = 30: pt1(1) = -102 I, T& c- C( @  ~1 ?. Q) p
  19.     pt2(0) = 30: pt2(1) = 30
    5 B, J; M: S0 F
  20.     textObj.Mirror pt1, pt2
    9 M- q5 @" n) f& b" z- [' X
  21.     ThisDrawing.SendCommand "mirrtext 0 "    '恢复文字不镜像,一般都不镜像。& \3 `5 d' N, m* u3 u
  22. End Sub
复制代码
2.7、添加文字.zip (6.16 KB, 下载次数: 2)
 楼主| 发表于 2019-3-27 20:53:52 | 显示全部楼层
8、对象操作方法之复制、旋转、移动& c$ j: K' p/ }3 x6 [5 A7 R
9 C/ W$ a3 y1 h& l
AObject.Copy方法
同一位置复制指定对象!
  1. Sub 复制()& G- k* e! {% ~
  2.     Dim cir As AcadCircle, cirs As AcadCircle
    1 {$ O) J. U3 F, n2 m: Q! |$ x3 ]
  3.     Dim pt(2) As Double, r As Double
    3 p; F, y* O5 R! \$ d- z$ L. F
  4.     pt(0) = 5: pt(1) = 10: r = 15
    , ~/ i( L3 I7 G/ ]3 i
  5.     Set cir = ThisDrawing.ModelSpace.AddCircle(pt, r)
    # Q/ Q! p% t2 b3 t
  6.     Set cirs = cir.Copy   '复制绘制的圆,但是复制的圆还在原地
    ! i+ G" H- D0 K5 d; j, ]
  7.     cirs.color = acBlue   '设置复制的圆的颜色" q; O% d  Y& B( J( `& j% C3 |
  8. End Sub
复制代码
' r7 }# w0 U6 N
. R0 l1 n) I! A/ B
BObject.Rotate方法
语法:Object.Rotate BasePoint, RotationAngle
Object使用该方法的所有图形对象
BasePoint指定旋转中心点坐标(Double类型,3元素数组)
RotationAngleDouble类型,以弧度表示的用于旋转对象的角度。正值逆时针旋转、负值顺时针旋转。注意该方法仅是旋转对象,不能复制旋转!想要旋转时复制对象,可以先复制对象,然后在旋转。
需注意:旋转、移动等方法操作的就是原对象,不会产生新的对象,所以旋转、移动等操作的结果不能赋给新的对象变量! Set l01 =l1.Rotate(旋转中心,旋转角)会提示错误!!!
  1. Sub 旋转对象()
    $ b* X: B- f! r+ r7 O7 Z: `
  2.     Dim plineObj As AcadLWPolyline4 u+ |( J9 T( K
  3.     Dim points(0 To 11) As Double
    : x! J; L5 I1 N
  4.     points(0) = 1: points(1) = 2) p  j0 F$ @  w! G) M
  5.     points(2) = 1: points(3) = 3
    7 s. q9 d1 D0 i/ E; g
  6.     points(4) = 2: points(5) = 3) w# J' |7 S( j
  7.     points(6) = 3: points(7) = 32 A1 V9 y4 R. `, q. o" l
  8.     points(8) = 4: points(9) = 42 [6 D% \6 ]( ^* U- i
  9.     points(10) = 4: points(11) = 2
    ' Y9 O4 v, D  d2 l+ }; e# v* s
  10.     Set plineObj = ThisDrawing.ModelSpace.AddLightWeightPolyline(points)% k2 ]# T# G, h
  11.     plineObj.Closed = True  'true表示多段线或样条曲线为闭合的,False(默认)表示多段线或样条曲线为开放的.( Z* i5 T" k$ B0 q7 O3 e
  12. zoomAll    '全部显示
    5 j* s5 b) Y7 _& {5 \  o; J
  13.     Dim basePoint(0 To 2) As Double     '定义旋转中心% a8 e' g# j* E' Q5 ], L" x
  14.     Dim rotationAngle As Double         '定义旋转角
    * g) H" q: c6 ]6 Q3 u4 {: E5 I. x& |
  15.     basePoint(0) = 4: basePoint(1) = 4.25: basePoint(2) = 06 a+ G2 h, G  ^6 Y: d
  16.     rotationAngle = 0.7853981   ' 45°,转化为弧度,正值逆时针旋转
    $ ]/ M* t5 a; Y5 D( ^+ q1 @9 ~
  17.     plineObj.Rotate basePoint, rotationAngle, t8 w* [' W6 |; T
  18.     Update% h* M( Y( O/ B# T. I
  19.     rotationAngle = -0.7853981   ' -45°,转化为弧度负值顺时针旋转
    ! e2 R* g% Z) \/ A; G
  20.     plineObj.Rotate basePoint, rotationAngle" b( L7 b( F6 U* n: y2 d( N& T& x. H
  21.     Update5 v/ m+ r6 g, U, b. r6 z
  22.     ZoomAll: t) @, G7 d0 A$ Y* q. o+ I( C
  23. End Sub
复制代码
以上代码仅旋转对象,想要实现旋转复制,需要先复制对象,然后旋转。
  1. Sub 旋转复制()
    , W$ C  f$ X; ~6 E1 ~; `" E
  2.     Dim plineObj As AcadLWPolyline! x( V6 H- @; E# I% \; {
  3.     Dim copypl As AcadLWPolyline  e* K- b; K# X  E6 X
  4.     Dim points(0 To 11) As Double' y3 M% ~' X' v2 |8 {( F; U
  5.     points(0) = 1: points(1) = 2
    $ g" R3 Q  R9 ?, J+ Z7 h
  6.     points(2) = 1: points(3) = 36 ?- C  P1 _; h: R" d9 a2 z( |, k
  7.     points(4) = 2: points(5) = 3
    1 m' d5 L4 \% i" T6 W  n9 S
  8.     points(6) = 3: points(7) = 3
    & |% Q' w2 ~9 h8 A
  9.     points(8) = 4: points(9) = 48 C) N1 _0 s! E( A4 g9 O
  10.     points(10) = 4: points(11) = 2
    # U- h: T9 z( B$ K% g
  11.     Set plineObj = ThisDrawing.ModelSpace.AddLightWeightPolyline(points)
    3 A- A% h( ]  [: i' {
  12.     plineObj.Closed = True  'true表示多段线或样条曲线为闭合的,False(默认)表示多段线或样条曲线为开放的.' Q7 O3 o( r& D& J5 V! ~
  13.     ZoomAll    '全部显示
    $ ?9 ~4 ]# S+ _
  14.     Dim basePoint(0 To 2) As Double     '定义旋转中心
    5 ]/ b! n* V+ m' C
  15.     Dim rotationAngle As Double         '定义旋转角9 G$ Q: _: z% {9 x. j8 _3 f
  16.     basePoint(0) = 4: basePoint(1) = 4.25: basePoint(2) = 0
    $ B+ |0 `* [8 U- q
  17.     rotationAngle = 0.7853981   ' 45°,转化为弧度,正值逆时针旋转* \# a7 V; @& A
  18.     Set copypl = plineObj.Copy  '复制多段线9 A" B# s- y1 J( J
  19.     copypl.Rotate basePoint, rotationAngle  '逆时针旋转复制的多段线7 N. t6 l; @6 a' Z# r9 Q7 Y
  20.     copypl.color = acBlue: r5 ?9 i- B* ^3 y
  21.     Update1 _1 A4 C! }5 r: N# t; _) f6 i' w
  22.     rotationAngle = -0.7853981   ' -45°,转化为弧度负值顺时针旋转3 L2 X$ Z- b" h6 \
  23.     Set copypl = plineObj.Copy   '再次复制原多段线
    % o8 A" c9 \. @: U' b
  24.     copypl.Rotate basePoint, rotationAngle    '顺时针旋转复制的对象$ V5 e4 c/ c' ~2 m) c
  25.     copypl.color = acGreen* Q. ?! ~9 x) G( E4 C) A
  26.     Update
    " S. l, K7 ^+ M7 V" a0 n+ o& W
  27.     ZoomAll5 _7 K  u" C/ J# P1 b/ Z4 B! Y
  28. End Sub
复制代码
以上代码是先复制对象,然后旋转复制的对象,实现了旋转复制。

! r4 u+ O: y) kCObject.Move方法
语法:Object.Move Point1, Point2 将对象按照点1到点2的向量方向移动向量的模长距离。
  1. Sub 移动()% D% i9 Z. j8 k0 I- S
  2.     Dim circleObj As AcadCircle1 X( ~$ F5 j( a& R/ B6 r8 x
  3.     Dim cirs As AcadCircle
    - r6 R* m7 Z7 H
  4.     Dim center(0 To 2) As Double
    + p: t8 x9 W3 }% @
  5.     Dim radius As Double
    + S9 ^- i& u! |1 o
  6.     center(0) = 2#: center(1) = 2#: center(2) = 0#) R2 W5 `# `: u6 j0 l, j. q- ]7 U
  7.     radius = 0.5: g+ d! \" B6 D" j% N- u
  8.     Set circleObj = ThisDrawing.ModelSpace.AddCircle(center, radius)& w& T4 o1 c( D$ u; N0 u( M
  9.     Update* q6 H/ ^' V9 _. d: B# t/ z8 |
  10.     Dim point1(0 To 2) As Double% e. s* I  @; L* T  w+ N  T: ~. k
  11.     Dim point2(0 To 2) As Double
    % D4 e' v8 ~$ O' K2 j0 k7 z
  12.     point1(0) = 0: point1(1) = 1: point1(2) = 0" A# L# ~$ D" `, j! T, T
  13.     point2(0) = 2: point2(1) = 6: point2(2) = 0
    . }/ }9 [& b2 C
  14.     Set cirs = circleObj.Copy
    ) B5 B7 l  S8 I9 ?' g6 O
  15.     cirs.Move point1, point2    '移动复制的对象+ A& ^! S/ @, K2 s
  16.     cirs.color = acCyan( \1 }: _' G# v& ?2 \, y
  17.     ZoomAll
    6 }5 J" i/ N8 |  U+ f8 {
  18. End Sub
复制代码
2.8复制、旋转、移动.zip (7.33 KB, 下载次数: 2)
 楼主| 发表于 2019-3-27 21:09:10 | 显示全部楼层
本帖最后由 kuangben8 于 2019-3-27 21:40 编辑
5 B( G7 j) U- v% R( O7 w7 o1 ^4 B) ]' }9 e5 \0 p
9、常用对象的常用方法、属性、事件      
6 W$ w, d  I' ~6 r+ B7 d

# v; j8 c  a- Q; L       至此,绘制一般的图形,应该没啥问题了!但其实AutoCAD除了给予图形对象的创建方法外,还给予了对象自身很多的操作方法及属性值,通过获取或者修改对象的属性值,可以更加简便的获取我们想要的图形数据。所以本节我们总结一下常用图形对象的常用方法及常见属性值。在AutoCAD中大部分对象的操作方法及属性都相同,所以一通百通!下面以多段线为例,概括一下常用的对象方法及属性、事件。; N  @+ ^" Z1 b8 k: o
A、常用对象的方法列表( V% \* J# m* P* f$ q; {. _
  方法
对应作用
AddVertex  
向优化多段线中添加顶点。
ArrayPolar  
以给定的对象数量、填充角度和中心点创建对象的环形阵列。
ArrayRectangular  
创建对象的二维或三维矩形阵列。
Copy
同一位置复制给定对象。
Delete  
删除指定对象或一组保存了的图层设置。
Explode  
将复合对象分解为子图元。
GetBoundingBox  
返回图元对象边框的最大和最小点。
GetBulge  
获取多段线上给定索引位置的凸度值。
GetExtensionDictionary  
获取与对象关联的扩展词典。
GetWidth  
返回多段线的起始和终止宽度。
GetXData  
获取与对象关联的扩展数据(XData) 。
Highlight  
设置给定对象或给定选择集中所有对象的亮显状态。
IntersectWith  
获取对象与图形中其它对象的相交点。
Mirror  
围绕轴创建平面对象的镜像图像副本。
Mirror3D  
绕由三点定义的平面镜像选定的对象。
Move
将图元对象从源向目标移动。
Offset  
创建由现有对象偏移指定距离的新对象
Rotate  
绕一点旋转图元对象。
Rotate3D  
绕三维直线旋转图元对象。
ScaleEntity  
按指定的基点和比例因子来缩放图元对象。
SetBulge  
设置多段线在给定索引位置的凸度。
SetWidth  
设置多段线上给定段索引的起始和终止宽度。
SetXData  
设置与对象关联的扩展数据 (外部数据) 。
TransformBy  
给定4×4转换矩阵移动、缩放或旋转对象。
Update
更新图形屏幕的对象。
1 U+ x, t, q" T& O: }7 d
2 x8 t- O% E! D0 k* j: i
B、常用对象的事件列表
. @4 e( \9 u% l( d
  事件
对应作用
Modified
图形中的对象和集合被修改时触发。

* Q/ {$ O* w  C5 a9 v+ `6 Q/ T2 n) T- i$ Z+ o: E
C、常用对象的属性列表
3 P$ ^/ F0 [1 Y/ z
  属性
对应作用
Application  
获取  Application 对象。只读属性
Area
指定构成弧、圆、椭圆、填充图案、优化多段线、多段线、面域或平面闭合样条曲线的封闭区域的面积。对于圆可修改,其他图形是只读属性
Closed  
决定三维多段线、优化多段线、多段线或样条曲线是否闭合。
ConstantWidth  
指定多段线的固定宽度。
Coordinate  
指定对象中单个顶点的坐标。
Coordinates  
指定对象中每个顶点的坐标。
Document  
获取对象所属的文档(图形)。只读属性
Elevation  
指定图案填充或多段线的当前标高
Handle  
获取对象的句柄。只读属性
HasExtensionDictionary  
确定对象是否有扩展词典与其关联。只读属性
Hyperlinks  
获取图元的 Hyperlinks 集合。只读属性
Layer  
指定图元的图层。
Length  
获取对象的长度。只读属性
Linetype  
指定图元的线型。
LinetypeGeneration  
指定二维多段线或优化多段线的线型生成方式。
LinetypeScale  
指定图元的线型比例因子。
Lineweight  
指定个别图元的线宽或图形的默认线宽。
Normal  
指定图元的三维法向单位矢量。
ObjectID  
获取对象的对象ID。只读属性
OwnerID  
获取所有者(上层)对象的对象ID。只读属性
PlotStyleName  
指定一个对象、一组对象或图层的打印样式名称。
Thickness  
指定二维 AutoCAD 对象按其平面向上或向下拉伸的距离。
TrueColor  
指定对象的真彩色。
Visible
指定对象或应用程序的可见性.
Angle
指定直线的角度。————————Line属性。只读属性
Delta
指定直线的增量。————————Line属性。只读属性
EndPoint
指定弧、直线或椭圆的终点。————————Line属性。对于Arc和Ellipse对象该属性为只读。Line可读写
StartPoint
指定弧、直线或椭圆的起点。————————Line属性。对于Arc和Ellipse对象该属性为只读。Line可读写
Center
指定圆弧、圆、椭圆、视图或视口的中心。————————Circle属性
Radius
指定圆弧或圆的半径。————————Circle属性
Circumference
指定圆的周长。————————Circle属性
Diameter
指定圆的直径。————————Circle属性
ArcLenth
指定圆弧的弧长。————————Arc属性。只读属性
EndAngle
指定弧或椭圆的终止角度。————————Arc属性
StartAngle
指定圆弧或椭圆的起点角度。————————Arc属性
TotalAngle
获取圆弧的总角度。————————Arc属性。只读属性
) f" D7 J+ i$ g9 A5 V6 E  `
      表中标明只读属性的表示只能获取对象的对应属性值,不可以修改对象的对应属性值。其他非只读属性可以修改对应属性值,相当于对图形进行编辑。了解一下大部分对象共同具有的属性及方法后,后续学习到新的对象,对比学习一下新的属性值和操作方法即可(如属性表后续增加内容)。
( T# C' q, S* P
+ t6 X  Q; k3 m9 [# A
 楼主| 发表于 2019-3-27 21:21:40 | 显示全部楼层
本帖最后由 kuangben8 于 2019-3-27 21:41 编辑
/ h) a4 s# {8 F7 a. Z! K) F. X
6 D$ }+ \3 J+ g0 }  y  O' ID、常用方法示例
注意:
1关于偏移的注意:OFFSET的结果是一个对象数组,赋值时不用set,获取结果中的对象时需用索引号(一般用0获取第一个)
2关于删除的注意:当用户删除集合中的对象时,集合中所有剩余项目会依据目前的计数重新指定新的索引。因此当处理整个集合时,应避免执行删除对象的循环。
3关于旋转的注意: Rotate只是旋转某个对象,旋转的结果不能赋给某个对象变量。
所以Set l01= l1.Rotate(midl1pt, 3.1415926 / 2)        会提示错误!
l1.Rotate midl1pt, 3.1415926 / 2              没问题!
类似的还有Move方法,凡是对原对象操作不会产生新的对象的方法,结果都不能重新赋给新的变量!
  1. Sub 对象常用方法()
    * v0 K8 @0 _/ L/ M) q
  2.     Dim L As AcadLine- r* \2 I' D5 b- ~
  3.     Dim p1(2) As Double, p2(2) As Double# i: l( ]8 B7 m& ]" K4 Q
  4.     Dim cir As AcadCircle3 B: y& c7 w8 |$ D! p  q% |
  5.     Dim p0(2) As Double, R As Double" J+ [! O6 i5 `& v; ?! E
  6.     Dim pl As AcadLWPolyline* R5 }) }0 G( o5 R' \8 r9 F5 l" F5 f
  7.     Dim ps(7) As Double
    6 h4 ~" ?0 r, r- J, x
  8.     p1(0) = 10: p1(1) = 101 d- m$ a: \; {7 A1 @* G
  9.     p2(0) = 100: p2(1) = 100
    - y" I$ D9 ~  `) X) j& l0 l
  10.     Set L = ThisDrawing.ModelSpace.AddLine(p1, p2)
    $ a# U8 K" K# z6 w: A6 `* A, A' O9 K1 l
  11.     L.Update  a& m9 N2 [( z
  12.     p0(0) = 20: p0(1) = 30: R = 50% V2 U! U8 I& B; q
  13.     Set cir = ThisDrawing.ModelSpace.AddCircle(p0, R): K% T9 C1 L& D& I
  14.     cir.Update. y$ g) v' h9 K+ `* w. V
  15.     ps(0) = -40: ps(1) = 40) p# a8 k0 ?2 O/ v6 g
  16.     ps(2) = 8: ps(3) = 10; n/ d; q0 M  ^) E# R
  17.     ps(4) = 40: ps(5) = 20, L" j% v) S& a
  18.     ps(6) = 60: ps(7) = 98
    4 O: _- d/ r3 A; ?! o* G
  19.     Set pl = ThisDrawing.ModelSpace.AddLightWeightPolyline(ps): m+ d- v0 X8 @+ H
  20.     pl.Update7 q  v( e7 R9 A8 t
  21.     Rem 接下来演示复制、移动、旋转、镜像、偏移、删除3 i* t1 S) l9 q" ?- D8 _4 H6 B' j
  22.     Dim p3(2) As Double, p4(2) As Double, ang As Double% a- L2 ~8 o( F6 ?
  23.     Dim copycir As AcadCircle, copy As AcadLine, copypl As AcadLWPolyline, mirpl As AcadLWPolyline, offsetpl As Variant
    & w+ x' t! @! l) E0 w- Z
  24.     Dim obj As Object6 c1 `1 \* S, Z4 P! _; p
  25.     p3(0) = 100: p3(1) = -20+ K/ l5 c9 C3 v/ v% d0 ~
  26.     p4(0) = 160: p4(1) = 90
      \( ~8 S& @  Y2 `& E6 K3 l
  27.     ang = 60 * 3.14 / 180    '指定旋转角度(弧度值). Q9 `4 f; t; K" N
  28.     Set copycir = cir.copy   '先在原位置复制圆. {! Q& h/ ^5 T! d. p% U
  29.     copycir.Move p3, p4      '移动复制的圆) X. s6 V2 z+ }1 h1 N& p
  30.     Update
    7 N5 t  h: h, v3 A' K, |3 N2 o: [! V8 V
  31.     Set copypl = pl.copy     '先在原位置复制多段线0 V3 g, p% g4 H8 M; }  Y3 K
  32.     copypl.Rotate p3, ang    '在旋转复制的多段线8 J/ n4 T1 t1 r9 N- u6 M
  33.     Update
    ) w& O  F6 p7 ]) ^+ a
  34.     Set mirpl = copypl.Mirror(p3, p4)    '镜像复制的多段线并赋给mirpl
    5 a3 @+ I5 N$ e8 \4 m0 H1 u
  35.     Update
    7 i2 L2 ~. Q6 k( ?' P
  36.     mirpl.Offset (50)   '顺时针多段线,正值向内偏移,负值向外偏移。
    3 y' ]+ C! U: k$ n3 f& C
  37.     Update0 s* b3 G( `% C0 x/ _5 ]
  38.     offsetpl = mirpl.Offset(-50)   '偏移的结果是对象数组,所以offsetpl定义为变体型,赋值时不需要set(对象赋值时必须使用)
    & [% L  K( P2 A' D' U
  39.     Update" x: a& n9 I) i/ y
  40.     offsetpl(0).color = acGreen  '设置偏移后的对象颜色属性值为绿色,虽然只有一个对象,但属于从数组中获取,所以以索引号0获取第一个。4 g3 b8 {3 @6 d, V( B% e
  41.     Update
    7 i" `! O# Y( H; v, w8 ]4 x
  42.     Rem 接下来删除所有对象0 D' ]  W8 a  K$ i
  43.     offsetpl(0).Delete                       '可以删除指定名称的对象
    2 O5 w6 S" z- {7 ?  y
  44.     Update' V- m' _1 V. W  p5 |+ t" T
  45.     For Each obj In ThisDrawing.ModelSpace   '在当前画布模型空间中
    & I) V8 k% u, V9 D6 B' T; I
  46.         obj.Delete                           '删除对象,似乎是按照绘图顺序依次删除对象的!9 ?' ]' I9 e, |
  47.         Update' a2 J9 Q7 _/ v& O+ o& z" ^
  48.     Next
    1 c1 E" F. Q6 a1 R7 H
  49. End Sub
复制代码
& j, s/ k- _% p( @

+ f9 e' O6 _  m, ~- U2 {, {# k+ ~% {
3 K  |4 H' t% H" q* A$ g" m
 楼主| 发表于 2019-3-27 21:58:11 | 显示全部楼层
获取交点语法: RetVal = object.IntersectWith(IntersectObject, ExtendOption)  获取交点坐标
Object:使用该方法的对象或对象集合。
IntersectObjectObject[对象], 为输入项; 对象可以是所有图形对象中的任一个。
ExtendOptionAcExtendOption常数; 为输入项,该选项指定两个对象中是否没有、单个或两个对象延伸来得到交点。有如下4个参数:
acExtendNone       两个对象均不延伸              acExtendThisEntity    延伸基本对象。
acExtendOtherEntity  延伸作为参数传递的对象。      acExtendBoth        延伸两个对象。
RetVal获取的结果是交点的坐标组成的数组。注意不是点的数组,而是坐标数组,所以有多个交点时,后续需要分别取值赋给点变量才能形成多个点对象
如果两个对象不相交,则没有返回数据。用户可以要求一个或两个对象延伸相交来产生相交点。
  1. Sub 获取交点()8 [& y7 H, K( G, C- f+ b+ L; p
  2.     Dim L01 As AcadLine, L02 As AcadLine, L03 As AcadLine2 P8 n2 `& X( ?, Y0 R" G
  3.     Dim p1(2) As Double, p2(2) As Double
    ! d% L  `4 z) [/ M: z. l; W( E
  4.     Dim p3(2) As Double, p4(2) As Double  g8 ?) `. O3 x$ Y4 s& ~
  5.     Dim p5(2) As Double, p6(2) As Double; Q5 h! i2 w4 b6 I& y. P: }0 p
  6.     Dim cir As AcadCircle# x) m" G- b! T- t( s
  7.     Dim p0(2) As Double, R As Double0 U- U2 f" z) U0 b' e
  8.     Dim pl As AcadLWPolyline# t" a, [8 A- {. v% T" K
  9.     Dim ps(7) As Double/ h: d1 Y+ Z  _& ]! p
  10.     p1(0) = 10: p1(1) = 10
    . M" q. B. M! J, |  Y' _
  11.     p2(0) = 100: p2(1) = 1002 W$ J) S+ ^! k9 ^; e4 ~& x
  12.     p3(0) = 80: p3(1) = 30& D2 q6 }8 V! V0 q$ R
  13.     p4(0) = 130: p4(1) = 30
    + j% I& u% A6 l! A
  14.     p5(0) = 150: p5(1) = 408 ~/ ^" p" X# k- D% h2 k6 l, [
  15.     p6(0) = 160: p6(1) = 702 M6 Z! v0 a# ^! i0 m( ?- s
  16.     Set L01 = ThisDrawing.ModelSpace.AddLine(p1, p2)( _" q7 i& r. V+ [" F, T" b5 {
  17.     L01.Update; u* }3 T5 W) c4 C0 o1 b
  18.     Set L02 = ThisDrawing.ModelSpace.AddLine(p3, p4)$ c! a9 f, v. t. A
  19.     L02.Update1 n: \: N( ^# o: i# L2 o0 c* T* C
  20.     Set L03 = ThisDrawing.ModelSpace.AddLine(p5, p6)
    # {0 K7 P# ^. c
  21.     L03.Update: [( e; W5 e% O. ?
  22.     p0(0) = 20: p0(1) = 30: R = 50' I- M5 N4 P8 A2 ~% F# w$ L9 V
  23.     Set cir = ThisDrawing.ModelSpace.AddCircle(p0, R)
    ' K) G; E$ r% i, C8 Q3 l" d
  24.     cir.Update
    ) K( s$ [! Z$ v5 z! L! h1 ~
  25.     ps(0) = -40: ps(1) = 40+ K& o3 W- J5 w7 X
  26.     ps(2) = 8: ps(3) = 10' h4 i5 q- `, s$ C7 _
  27.     ps(4) = 40: ps(5) = 202 \; f6 `8 s: H/ O
  28.     ps(6) = 60: ps(7) = 98$ C- l4 E1 a4 O9 B8 i: `
  29.     Set pl = ThisDrawing.ModelSpace.AddLightWeightPolyline(ps)
    2 z( u" w6 ?  ^) h& t
  30.     pl.Update; \/ X' e' c: \
  31.     Rem 接下来获取交点坐标( Y  S. b# y, o. N  f4 K
  32.     Dim ppt01 As Variant, ppt02, ppt03, ppt04           '默认是变体型  e2 w9 Z( I. t! i. y' ]
  33.     ppt01 = L01.IntersectWith(cir, acExtendBoth)        '两个都延伸,获得延伸后的交点坐标
    6 d' e5 ]  k% Y1 T1 W& o
  34.     ppt02 = L01.IntersectWith(cir, acExtendNone)        '两个都不延伸,获得唯一1个交点坐标
    : o2 n- z' I* O+ \
  35.     ppt03 = L01.IntersectWith(cir, acExtendOtherEntity) '延伸作为参数传递的对象,延伸圆,所以结果还是1个交点坐标
    ' `: z) [' b- p8 c- s
  36.     ppt04 = L01.IntersectWith(cir, acExtendThisEntity)  '延伸基本对象,延伸基本对象L01,所以结果是2个交点坐标
    4 u: W4 ?# O4 h
  37.     Rem 以上是L01与圆的交点情况2 y! V% i3 @& ?: H# u
  38.     ppt01 = L01.IntersectWith(L02, acExtendBoth)        '两个都延伸,可以获得一个交点坐标
    0 {( S; W& {; |" Q
  39.     ppt02 = L01.IntersectWith(L02, acExtendNone)        '两个都不延伸,不相交,所以无交点坐标' g, q; n  }! E! x3 n# S. I6 ]
  40.     ppt03 = L01.IntersectWith(L02, acExtendOtherEntity) '延伸作为参数传递的对象,延伸L02,所以获得一个交点坐标
    # P% ]' B0 @' J7 i
  41.     ppt04 = L01.IntersectWith(L02, acExtendThisEntity)  '延伸基本对象,延伸L01,仍然无交点坐标
    ! t( [, k# ?# f6 }; o- A% p
  42.     Rem 以上是L01与L02直线的交点情况
    ) k9 z- X7 [: `) c# T: P8 n
  43.     ppt01 = L02.IntersectWith(L03, acExtendBoth)        '两个都延伸
    2 R3 T! }* E* _0 k9 L
  44.     ppt02 = L02.IntersectWith(L03, acExtendNone)        '两个都不延伸; j$ D! |! H/ A5 L% E& L# Q8 Q
  45.     ppt03 = L02.IntersectWith(L03, acExtendOtherEntity) '延伸作为参数传递的对象2 E, z! E: Y0 E$ }3 M2 I2 V# p
  46.     ppt04 = L02.IntersectWith(L03, acExtendThisEntity)  '延伸基本对象
    % @: l/ _5 Q7 Z
  47.     Rem 以上是L02与L03交点情况
    0 n# \* G! C$ u5 @! e
  48.     ppt01 = L03.IntersectWith(cir, acExtendBoth)        '两个都延伸
    2 O4 k" C4 M, h: m8 H9 u) ]
  49.     ppt02 = L03.IntersectWith(cir, acExtendNone)        '两个都不延伸7 ~4 x* n' y1 |3 A3 X- A$ I
  50.     ppt03 = L03.IntersectWith(cir, acExtendOtherEntity) '延伸作为参数传递的对象$ \" {5 h# K" p1 ^& C8 j/ _8 s# H7 W
  51.     ppt04 = L03.IntersectWith(cir, acExtendThisEntity)  '延伸基本对象
    9 d+ y1 o# ]  k: e& C& U
  52.     Rem 以上是L03与圆交点情况
    9 ]3 M! f0 a  p6 H* T( l
  53.     ppt01 = L02.IntersectWith(pl, acExtendBoth)        '两个都延伸, a9 X* Q: F. H' i! D  y/ t, i
  54.     ppt02 = L02.IntersectWith(pl, acExtendNone)        '两个都不延伸8 I: z1 h. K/ T- P9 a" O
  55.     ppt03 = L02.IntersectWith(pl, acExtendOtherEntity) '延伸作为参数传递的对象
    7 ?1 Y6 d) o1 b$ w( y9 A3 h
  56.     ppt04 = L02.IntersectWith(pl, acExtendThisEntity)  '延伸基本对象& ?, {+ s* R% d: s  C9 h
  57.     Rem 以上是L02与多段线交点情况
    5 v9 k7 F7 `* t4 f! U
  58.     ppt01 = L01.IntersectWith(pl, acExtendBoth)        '两个都延伸6 k$ C, x) M* l; x
  59.     ppt02 = L01.IntersectWith(pl, acExtendNone)        '两个都不延伸
    % a" |% R7 Y7 |& W6 M( }- U
  60.     ppt03 = L01.IntersectWith(pl, acExtendOtherEntity) '延伸作为参数传递的对象
    * K) R) t. R+ i. P/ a
  61.     ppt04 = L01.IntersectWith(pl, acExtendThisEntity)  '延伸基本对象4 f' l- D4 [4 V1 y
  62.     Rem 以上是L01与多段线交点情况
    . z" v# n8 j! N* N. b& T# n
  63.     Rem 通过以上几种示例结合本体窗口中ppt01、ppt02、ppt03、ppt04的结果理解四个参数的区别
    : F+ j) M! d+ i  |1 G7 Y4 N
  64. End Sub
复制代码
程序包见下楼!

% F6 c# ]( }' o) N8 Q, Y
 楼主| 发表于 2019-3-27 22:03:09 | 显示全部楼层
E、常用属性示例
注意:1直线角度Angle是按照直线起点为坐标原点,起点所在水平线为基准线逆时针旋转至直线处的角度。所以画直线时起点和终点互换位置后对应的直线角度不同!
  1. Sub 常用对象属性(): C; O5 \2 K6 E( z3 g  W$ W
  2.     Dim L01 As AcadLine
    * D* d, b- O4 }9 D0 `
  3.     Dim p1(2) As Double, p2(2) As Double: X2 D' G+ ^. ~% x0 a. e
  4.     Dim cir As AcadCircle
    ( D; d* [1 E6 ~0 e
  5.     Dim p01(2) As Double, R1 As Double. n4 f' q* S9 x9 e, s  D- ~4 P2 U
  6.     Dim pl As AcadLWPolyline+ [. a" w  s; |8 h( c$ a  c
  7.     Dim ps(7) As Double
    0 ?% H5 A& `* z' p
  8.     Dim arc As AcadArc! c+ i- g( f) _4 E( D0 c5 I6 m
  9.     Dim p02(2) As Double, R2 As Double, fstangle As Double, endangle As Double! J& b/ D6 {" E9 }! V
  10.     p1(0) = 10: p1(1) = 10* q6 o* |; T0 @# I. a, x, p
  11.     p2(0) = 100: p2(1) = 100
    * c5 R4 E" F% w" c- d& k2 f% M
  12.     Set L01 = ThisDrawing.ModelSpace.AddLine(p1, p2)
    ; w, U! j, U& [( s/ u
  13.     L01.Update8 ~# |; m9 Q  h, o6 Q3 X) c
  14.     p01(0) = 20: p01(1) = 30: R1 = 50% R! \8 t; ?; l5 y! X
  15.     Set cir = ThisDrawing.ModelSpace.AddCircle(p01, R1)* H' `' W$ P0 G; @
  16.     cir.Update6 t+ H4 M* Q& r- y, K+ S: H9 C
  17.     ps(0) = -40: ps(1) = 40# O- y* R5 w2 V2 s' j, r
  18.     ps(2) = 8: ps(3) = 10: C8 |* V5 [2 J) A6 N3 e, F9 x
  19.     ps(4) = 40: ps(5) = 20- x4 s; m" m! k" b. ]* n
  20.     ps(6) = 60: ps(7) = 985 z% r, S8 [+ J+ g& H
  21.     Set pl = ThisDrawing.ModelSpace.AddLightWeightPolyline(ps)
    * N  B& @5 g  e" U" T4 y
  22.     pl.Update
      G2 X& c3 d- W4 P. k
  23.     p02(0) = 50: p02(1) = 60: R2 = 80: fstangle = 60 * 3.14 / 180: endangle = -60 * 3.14 / 180& X  B, O, r/ H) u( O$ t. J
  24.     Set arc = ThisDrawing.ModelSpace.AddArc(p02, R2, fstangle, endangle)) u' |: {4 W7 Z6 l  t" g
  25.     arc.Update
    6 |7 q3 l  u8 f
  26.     Rem 接下来设置/获取对象属性
    2 R/ d# f2 j0 U4 E
  27.     Rem 多段线属性
      v$ L8 q. ]4 U7 M, c
  28.     Dim X As Variant( V4 E7 S! U' R* ]  ^: u
  29.     X = pl.Area          '返回闭合图形的面积,结果是double,值为4040,即使非闭合,系统自动按照起点和终点连接闭合图形计算
    , O8 G( m/ O; T( [
  30.     X = pl.Closed        '结果为false表示非闭合曲线,为true则表示闭合曲线  n/ f$ B3 ?6 `; U# L9 ?9 C; U
  31.     pl.Closed = True     '设置多段线为闭合曲线,系统会自动将多段线起点和终点连接闭合。3 J; ~( k6 W* Y% [0 Q% b
  32.     Update
    0 B& Z  |6 k+ R: M+ ]$ z
  33.     X = pl.ConstantWidth        '固定宽度为0(默认值)
    8 X- }3 E/ X/ }, v; r5 J. p
  34.     pl.ConstantWidth = 0.35     '设置多段线固定宽度为0.35mm,设定后线宽属性设置无效!
    2 x4 Y% M# Z. @# _5 O  ?( {
  35.     Update
    ! @$ f  r: a) L! v0 O0 Y6 r
  36.     Rem 该属性设置多段线所有段的起始和终止宽度为统一值。该属性只有在所有段设置为统一宽度时才返回固定宽度。3 v9 }( O; S2 F. q
  37.     Rem 可以使用 SetWidth 和 GetWidth 方法来指定各个段的宽度。. f$ Q0 t# V6 y6 ~" d. d
  38.     X = pl.Layer         '返回对象所在的图层名字0,string类型,亦可指定图层,参考“添加图层”。
    2 R5 n8 r  d1 @7 N
  39.     X = pl.Length        '获取对象的长度,属于只读属性,不可重新赋值!# V9 W( U& [3 ]# J# `- |& ?, K% T
  40.     X = pl.Linetype      '获取对象的线型"ByLayer",此处是随层,亦可指定线型. j3 q* Y) o6 p9 o) G; N
  41.     X = pl.LinetypeScale '获取多段线线型比例,亦可指定线型比例3 ^9 E; q1 C. R# f4 u# v+ y( m
  42.     X = pl.Lineweight    '获取多段线的默认线宽"-1"& \% u+ T+ s3 v: Z; j
  43.     pl.Lineweight = acLnWt100 '指定多段线的线宽为1.00mm,设定固定宽度后此属性值修改无效!
    ( Y4 ]5 U& E: b  e2 V3 i
  44.     Update! Z/ @( k8 P0 [- r  i  _
  45. '     pl.TrueColor=xxx     '该属性值是设置属性,不能获取!
    8 I1 ]  v2 i, s# [0 q
  46.     Rem 接下来了解直线属性
    0 ~' o. W& F  z  e
  47.     X = L01.Angle         '获取直线的角弧度(只读属性),该角度是由 X 轴开始并沿逆时针方向测量值。' Q7 [. @- @1 `2 G
  48.     X = L01.Delta         '获取直线的增量(只读属性),终点坐标相对于起点坐标增加的量!
    9 n4 z( i8 i, {" D
  49.     X = L01.EndPoint      '获取直线的终点坐标
    - K; ^) y, s$ M# D( s, R6 P  y5 J
  50.     X = L01.StartPoint    '获取直线的起点坐标& j4 y4 l3 O+ l3 r) O% _  ^
  51.     Rem 接下来是圆的属性& j% ?& j) w1 _
  52.     X = cir.Center        '获取圆的圆心坐标4 Q/ |9 I) F# f' s& K: b
  53.     X = cir.Radius        '获取圆的半径
    + }$ q: H, W5 K: L. t
  54.     X = cir.Circumference  '获取圆的周长
    ! t9 ]) ?. E$ Z& n: g( _2 ^
  55.     X = cir.Diameter       '获取圆的直径; P9 v# C+ q/ R/ x0 k4 B" ?
  56.     Rem 接下来是圆弧的属性
    # T7 X4 N: T9 l. m
  57.     X = arc.ArcLength       '获取圆弧弧长(只读属性)* ?: y/ X8 M* ]* p1 n, Q: ^8 |
  58.     X = arc.endangle       '获取圆弧的终止角弧度! N5 q1 Z, t: Y" t3 r
  59.     X = arc.StartAngle     '获取圆弧的起始角弧度
    : B- ~/ T' a; H  i
  60.     X = arc.TotalAngle     '获取圆弧的总角弧度(只读属性)$ x" q: Q. V( I& v' }
  61. End Sub
复制代码
2.9、常用对象的常用方法、属性、事件.zip (10.16 KB, 下载次数: 2)
 楼主| 发表于 2019-3-29 19:07:30 | 显示全部楼层
10、辅助绘图方法
在通过VBA绘图中发现很多手工绘图命令在VBA中并没有直接可用的命令,而需要转换.例如通过3点画圆方法,前面提到的是通过理论计算出圆心和半径,然后按照圆心、半径画圆即可。
也可以通过辅助绘图方式完成,然后将辅助线删除即可。
A、辅助三点画圆
辅助思路:3个点连接2条线段,绕各自中点旋转90°,交点就是圆心,交点与任意一点连线就是半径:画圆。
  1. Sub 辅助三点画圆()7 g6 ?! f7 [; g& b( J5 X' R
  2.     Rem 通过3点画两条线,然后分别以中点为基点旋转90°,取得相交点坐标就是圆心,圆心和任意点连线长度就是半径。
    # u, w  g1 ?( ^, r
  3.     Dim pt1(2) As Double, pt2(2) As Double, pt3(2) As Double' j/ @! T. E/ ]; @
  4.     pt1(0) = 100: pt1(1) = 60" u9 ~& t6 G9 |3 L9 h
  5.     pt2(0) = 70: pt2(1) = 95# b- }8 G# I; M% K% E7 ?
  6.     pt3(0) = 150: pt3(1) = 76
    & B! {# f3 x- N6 r" o& o
  7.     Dim l1 As AcadLine, l2 As AcadLine    '画两条辅助直线并求中点坐标
    $ k0 {" N# {- e7 w
  8.     Dim midl1pt(2) As Double, midl2pt(2) As Double   '定义中点坐标变量
    9 S( }9 v& ~$ w0 r+ `9 X  X: P
  9.     With ThisDrawing.ModelSpace2 y3 A  Q! H" s2 b; \. w. W  {
  10.         Set l1 = .AddLine(pt1, pt2)
    . Z9 L* T0 h( f, n  X9 P
  11.         Update
    * Q3 W6 t# f9 g
  12.         midl1pt(0) = (l1.StartPoint(0) + l1.EndPoint(0)) / 2/ y3 J7 k: P" L' m( u+ O  w; }" S2 m. ]
  13.         midl1pt(1) = (l1.StartPoint(1) + l1.EndPoint(1)) / 2' Z- }2 M# m5 h5 ?/ ?% u6 P' F, R
  14.         Set l2 = .AddLine(pt2, pt3)
    . |& I8 M: T/ l4 g" I1 `9 ~( W& `6 u
  15.         Update
    ) B4 Q+ w* }3 }# V( l
  16.         midl2pt(0) = (l2.StartPoint(0) + l2.EndPoint(0)) / 2" x  `6 E' C3 C' ?: J# i
  17.         midl2pt(1) = (l2.StartPoint(1) + l2.EndPoint(1)) / 2
    5 V6 Y" H0 v6 y* a
  18.     End With
    4 g) l: ]. P4 s4 x- |
  19.     Rem 复制并旋转90°* N. v. g* P0 R6 k5 Y
  20.     l1.Copy4 q- U$ y) O( }+ b
  21.     l2.Copy
    / _  C2 j% E# b$ n4 B, y
  22.     l1.Rotate midl1pt, 3.1415926 / 2    '旋转的结果还是l1
    ( |+ r% K; |+ c  x. S) N+ Y6 i8 E2 Z
  23.     Update$ H  |3 o4 m& W6 o2 ]# s
  24.     l2.Rotate midl2pt, 3.1415926 / 2    '旋转的结果还是l2: A, J1 D' `4 Q& v
  25.     Update' V/ F6 i0 t) Y) s
  26.     Dim p0, R As Double     '定义圆心和半径
    ' n- H; v6 a+ X' L# ]6 v; t+ p% x
  27.     p0 = l1.IntersectWith(l2, acExtendBoth) '获取交点坐标,两个都延伸,防止不相交! w6 A* p! i: Q4 ~5 m
  28.     R = Sqr((p0(0) - pt1(0)) ^ 2 + (p0(1) - pt1(1)) ^ 2)
    # l6 Z3 H% @- [/ Z. j& t
  29.     Dim cir As AcadCircle
    + {5 k* C3 E5 e
  30.     Set cir = ThisDrawing.ModelSpace.AddCircle(p0, R)1 j4 K, \0 M  d' O: Q9 Q
  31.     Update& n% h; S' ]9 t
  32.     Dim obj As Object, x   '定义对象变量
    9 ~/ [1 p, m1 d
  33.     For Each obj In ThisDrawing.ModelSpace9 v( ]0 a/ L$ g5 m1 b
  34. '    x = obj.Type     '没有这个属性,那怎么知道这个obj是什么类型呢?
    ; J* u) E3 |0 z; k5 ?# x, @$ b. }
  35.         If TypeOf obj Is AcadLine Then  '如果对象的图元类型是直线则删除
    4 f; ?5 S! c; e( U
  36.             obj.Delete1 Y2 {0 a+ t" H
  37.             Update
    4 z; f' O6 e! P/ d( P& o+ x+ ?' A
  38.         End If
    % H% N& A# w0 ^, o8 L; W/ w
  39.     Next
    7 x) ]. ?/ z1 F& H
  40. End Sub
复制代码
8 j( p$ [: T/ Z  j6 e0 y
新增的知识点:TypeOf
TypeOf是语句,只应用于 If ... Then ... 语句中
MSDN解释:TypeOf  <ObjectName>  Is  <ObjectType>形式的表达式。其中的ObjectName是任何对象的引用,而ObjectType则是任何有效的对象类型。如果ObjectNameObjectType所指定的一种对象类型,则表达式为True,否则为False
例如,将窗体中的所有文本框清空,用如下语句:
Dim c As Control
For Each c In Me.Controls
If TypeOf c Is TextBox Then c.Text =""
Next
5 \+ R2 X8 n# W: s
程序包见下楼。

. _' ?  k! d8 V  d2 M* |6 {
 楼主| 发表于 2019-3-29 19:13:58 | 显示全部楼层
B、辅助三点画弧
辅助思路:3个点连接2条线段,绕各自中点旋转90°,交点就是圆心,交点与任意一点连线长度就是半径,圆心与起点连线角度就是起始角,圆心与终点连线角度就是终止角。
  1. Sub 辅助三点画弧()* ?3 Z9 Q& V- G6 h5 [- `
  2.     Dim P1(2) As Double, P2(2) As Double, P3(2) As Double, l1 As AcadLine, l2 As AcadLine
    : Q( ?# l/ }9 |) C
  3.     P1(0) = 100: P1(1) = 60
    5 G% h, F( U/ V, r3 I2 _
  4.     P2(0) = 70: P2(1) = 952 J' y" z8 u* {% u3 R
  5.     P3(0) = 150: P3(1) = 76
    # A* |+ W: W& V* R" `
  6.     Set l1 = ThisDrawing.ModelSpace.AddLine(P1, P2)8 F4 u5 m/ N! r7 }
  7.     Update4 c; W. m( [1 t* v% J
  8.     Set l2 = ThisDrawing.ModelSpace.AddLine(P1, P3). h+ n3 c6 L- m* a3 M2 r% P
  9.     Update
    : C* V2 ]7 h; o2 b$ T
  10.     Dim p01(2) As Double, p02(2) As Double
    . ~; R1 v! t6 t
  11.     p01(0) = (P1(0) + P2(0)) / 2: p01(1) = (P1(1) + P2(1)) / 2
    ) }$ h& j% R9 A9 J  C
  12.     p02(0) = (P1(0) + P3(0)) / 2: p02(1) = (P1(1) + P3(1)) / 2
    6 {) ^2 O# k1 z
  13.     l1.Rotate p01, 3.1415926 / 2
    5 j3 b5 {" Y% ~: g' y' U4 G
  14.     Update$ x- v# [5 e7 m0 Y; V4 p
  15.     l2.Rotate p02, 3.1415926 / 2
    , K. h( W6 w) V; a
  16.     Update
    . e- M8 n; j3 `
  17.     Dim p0 As Variant, R As Double, l01 As AcadLine, l02 As AcadLine, arc As AcadArc
    6 o2 m$ D, }; ?3 C  v- i
  18.     Dim firstangle As Double, endangle As Double
    + q& i* J/ z) o2 T. I, D
  19.     p0 = l1.IntersectWith(l2, acExtendBoth): m. s4 g! d. b4 u& P3 n' n5 q/ `
  20.     Set l01 = ThisDrawing.ModelSpace.AddLine(p0, P2)   '圆心与起点连线,就是半径
    # L8 a" I% j! p$ s$ W4 o
  21.     Update
    / s3 v8 N* J% y' O5 h6 e) d
  22.     Set l02 = ThisDrawing.ModelSpace.AddLine(p0, P3)   '圆心与终点连线,也是半径
    9 ^0 k8 P$ h0 \6 z  ~- @
  23.     Update
    ; O+ F+ A- ]5 @+ v
  24.     R = l01.Length               'l01的长度就是半径/ [: A& T/ |; P! A1 e% f
  25.     firstangle = l01.Angle       'l01的角度就是起始角
    $ O% g# G. h& O1 @
  26.     endangle = l02.Angle         'l02的角度就是终止角5 J  W3 g* C  g( }
  27.     Set arc = ThisDrawing.ModelSpace.AddArc(p0, R, firstangle, endangle)   '画弧
    ; K. Q' Q5 Y8 E2 ^
  28.     Update* Y5 M7 A9 m+ O% d0 q
  29.     l1.Delete    '删除直线l1
    ; E: u3 {/ X( P: c5 O( C
  30.     Update
    . w4 {1 ]) b  o' _& v- ?6 [
  31.     l2.Delete    '删除直线l2
    - h0 M  R+ ^  T5 D) i, D& e
  32.     Update- a& f. n7 W4 I. K1 e1 l9 k$ e
  33.     Set l01 = ThisDrawing.ModelSpace.AddLine(P2, p0)   '圆心与起点连线,就是半径# ^; {, `# m8 [2 ~, f/ K6 k3 Z
  34.     Update7 E3 X% z6 c  c6 c( V
  35.     Set l02 = ThisDrawing.ModelSpace.AddLine(P3, p0)   '圆心与终点连线,也是半径
    6 n# W( j7 ], ?- y, x2 [
  36.     Update
    3 I0 [+ y, s# `& w% U/ l  p
  37.     R = l01.Length               'l01的长度就是半径1 d/ f, _- W1 D  r4 P8 j" [8 |+ B, d
  38.     firstangle = l01.Angle       'l01的角度就是起始角1 [. o) N. P6 ], m% t
  39.     endangle = l02.Angle         'l02的角度就是终止角. ~9 k% x5 _+ O
  40.     Set arc = ThisDrawing.ModelSpace.AddArc(p0, R, firstangle, endangle)   '画弧9 H" t- c* u- O" }
  41.     Update+ e1 Q+ e# B* o( E5 o% n4 L
  42.     Rem 通过以上两例发现,直线角度是按照直线起点为坐标原点,起点所在水平线为基准线逆时针旋转至直线处的角度。
    & I/ m; L; b$ }) F2 I, k
  43. End Sub
复制代码
  1. Sub 验证直线角度()
    + f; U" x  Z$ u+ P8 j
  2.     Dim P1(2) As Double, P2(2) As Double, l1 As AcadLine, l2 As AcadLine9 ?- q; S2 N) n: y6 b7 O
  3.     P1(0) = 100: P1(1) = 602 X% t5 T. `+ _2 i6 e3 d/ R2 H
  4.     P2(0) = 70: P2(1) = 95  K" t! }& q6 X. W3 t' f3 W+ Z
  5.     Set l1 = ThisDrawing.ModelSpace.AddLine(P1, P2)% |9 z0 {0 P, J( c9 L3 [/ Y
  6.     Set l2 = ThisDrawing.ModelSpace.AddLine(P2, P1), C% n$ }. P/ f% x* m5 s* g1 Z
  7.     Dim m, n
    9 ]7 O8 d" B3 G) u
  8.     m = l1.Angle * 180 / 3.1415926
    * F3 m6 F& J6 }. A) b  E  f
  9.     n = l2.Angle * 180 / 3.1415926& p% B* y" _1 t9 {( Y  s( x" E+ s
  10.     Rem 直线的角度是以起点为坐标原点,起点所在水平线为X正半轴逆时针旋转至直线处的旋转角度。$ ^9 C$ t  U2 k& D3 N) [
  11. End Sub9 Z  p' O3 f# ]( [1 J
复制代码

9 ~1 s# @7 |& O/ |
# f; b9 O& @; |, ], W8 X4 r) J* ?; K* D9 g- m8 s9 y
; S' S6 |% g4 r0 u7 k& X
 楼主| 发表于 2019-3-29 19:19:00 | 显示全部楼层
本帖最后由 kuangben8 于 2019-3-29 19:20 编辑
3 m, r0 @6 a: N% B3 b- f* ?: w, W# ?" b
C、辅助两点半径画弧
6 ?- M9 Z0 d& d辅助思路:分别以AB点为圆心,R为半径画圆,两圆交点就是圆心。圆心与起点连线角度就是起始角,圆心与终点连线角度就是终止角-----然后画弧。  q( I& _$ r0 [* W
  1. Sub 辅助两点半径画弧()
    ! N# L# F  I: f5 z; V
  2.     Rem 能画弧条件:两点距离小于2R,等于2R是半圆,大于2R不能形成图形6 z1 b: t7 s1 C
  3.     Rem 分别以A、B点为圆心,R为半径画圆,两圆交点就是圆心。圆心与起点连线角度就是起始角,圆心与终点连线角度就是终止角-----然后画弧。
    1 i, y: j6 P; D8 x; f
  4.     Dim p1(2) As Double, p2(2) As Double, R As Double, l As AcadLine) l  c  X0 ]2 K/ A
  5.     p1(0) = 30: p1(1) = 307 K' P, `- T, |. o4 v; @' n  l
  6.     p2(0) = p1(0) + 50 * 2 ^ 0.5: p2(1) = p1(1) + 50 * 2 ^ 0.5   '为了让线段长为100  S( D- r6 M( L8 B2 o8 }7 y8 b
  7.     R = InputBox("请输入圆的半径:"); q3 a. s  o. l# Q
  8.     Set l = ThisDrawing.ModelSpace.AddLine(p1, p2)7 q" Y- X; c. l) Q6 l8 z) ?$ n
  9.     Update2 o* i9 a, Z( `" w2 F/ Y6 Y
  10.     If l.Length > 2 * R Then" o  Y- [1 O6 U
  11.         MsgBox "两点距离大于直径,不能形成圆或圆弧", vbInformation, "AutoCAD提示!"( R* X, ~+ p) ]: o2 K; r, o, u
  12.     ElseIf l.Length = 2 * R Then
    ' y' i% P) b. [# Z9 C
  13.         Dim p0(2) As Double
    % d- @* {# X: a
  14.         p0(0) = (p1(0) + p2(0)) / 2: p0(1) = (p1(1) + p2(1)) / 2
    7 C4 D4 Z0 G6 ^0 P" p
  15.         ThisDrawing.ModelSpace.AddArc p0, R, l.Angle, 3.1415926 + l.Angle  '起始角是直线的角度,终止角是直线角度+180°
    3 `0 W- Y, E4 I( N1 P
  16.         Update7 `4 N$ m; C) Q" C
  17.         ThisDrawing.ModelSpace.AddArc p0, R, 3.1415926 + l.Angle, l.Angle
    . d$ g" H1 H3 j0 p9 h
  18.         Update& N0 |" V. A' D3 ^' F
  19.     Else
    ( a3 b- e/ q+ s% E
  20.         Dim cir1 As AcadCircle, cir2 As AcadCircle, ps As Variant, ps1(2) As Double, ps2(2) As Double, l01 As AcadLine, l02 As AcadLine: Z7 e; r4 B5 F0 I# o
  21.         With ThisDrawing.ModelSpace* t1 B- J1 @7 {. X8 R3 T6 h9 V* D& P
  22.             Set cir1 = .AddCircle(p1, R)
    , y' M$ w# g; r3 C* Z! T4 J7 w
  23.             Update
    6 o3 u) ], P. r- |6 ~6 X
  24.             Set cir2 = .AddCircle(p2, R)
    + B, L  H- I# |4 ?, i3 W- x! X7 \
  25.             Update2 b! {6 W* V) W+ ]5 _
  26.         End With
    ( l  M- t* C. b, _4 [
  27.         ps = cir1.IntersectWith(cir2, acExtendNone) '取两个圆的交点坐标,都不延伸
    . c- s2 B5 `% M% E
  28.         ps1(0) = ps(0): ps1(1) = ps(1)    '第一个圆心坐标
    " C7 k8 W! r1 ?. q2 v! a( X
  29.         ps2(0) = ps(3): ps2(1) = ps(4)    '第二个圆心坐标
    7 O% o. e: I: ^+ _! k( i2 I0 F
  30.         With ThisDrawing.ModelSpace
    0 o9 |2 H1 N  F% y: Z
  31.             Set l01 = .AddLine(ps1, p1)   '注意必须是圆心作为直线的起点1 Z- E( c$ h- I: i3 x
  32.             Update
    5 Z+ P- E4 }# [6 C; |
  33.             Set l02 = .AddLine(ps1, p2)   '注意必须是圆心作为直线的起点9 G$ V/ w7 |- {# m
  34.             Update
    & w7 N( X7 W' V  C/ {
  35.             .AddArc ps1, R, l01.Angle, l02.Angle    '圆心作为直线的起点,角度才是画弧需要的角度
    ( {' ?* N; ^2 O* Q/ ~/ c# c! p
  36.             Update
    ( X: f8 f: ?) J7 B5 k- h
  37.             1 k- P0 [! y6 s, V5 A
  38.             Set l01 = .AddLine(ps2, p1)* T  h! z# _2 F6 \+ i
  39.             Update
    " V% M( L  t; J; }. U4 L2 E
  40.             Set l02 = .AddLine(ps2, p2)4 r% t' X: N4 y0 j- `
  41.             Update9 i! d- q% I& l% Q
  42.             .AddArc ps2, R, l01.Angle, l02.Angle
    4 H3 X" ~* `2 G: Y( h) d: ?
  43.             Update
    & z! `7 c7 S8 G
  44.             .AddArc ps2, R, l02.Angle, l01.Angle
    3 Z: f( p/ k) p5 k; F" J( y
  45.             Update# C; ~8 B; |; h! }6 b. d
  46.         End With
    / `1 a' r" v9 m* x
  47. End If
    2 S1 f- `# ^  x: D0 L
  48. Dim obj As Object
    8 G% F3 J; m2 O0 @9 s! F" w+ ?, H
  49.     For Each obj In ThisDrawing.ModelSpace& p/ i/ S% f( J" N$ M0 W) R* x
  50.         If Not TypeOf obj Is AcadArc Then    '如果对象的图元不是圆弧则删除,按照绘图顺序删除。
    / ?( Y* _3 E# z  I' T/ Y6 U
  51.             obj.Delete
    + I( u8 I( e# g' Q8 _% d
  52.             Update
    & s( U/ {* E- x& Z+ e" D7 V
  53.         End If# O  {! T8 L0 |/ `
  54.     Next) f" _( w: R- g% y" Y, u
  55. End Sub
    ) U/ v5 J5 o. e; q- F. C6 g
复制代码
2.10、辅助绘图方法.zip (12.4 KB, 下载次数: 1)
 楼主| 发表于 2019-3-29 19:26:23 | 显示全部楼层
本帖最后由 kuangben8 于 2019-4-13 20:54 编辑 ) d* ~# E0 {; Z; w, K1 v

5 a7 R5 s$ m# }  m+ o$ M11、对象操作方法之图案填充(Hatch)
* I4 e" A1 r% l7 Q/ z

# |9 m0 M& Q' J2 S% `/ u( {% W- _A、创建图案填充
语法:RetVal = Object.AddHatch(PatternType, PatternName, Associativity [,HatchObjectType])
Object:使用该方法的对象
PatternType(图案类型): AcPatternType AcGradientPatternType 常数; 仅用于输入,如果 HatchObjectType 常数值为 acHatchObject,则使用 AcPatternType 常数; 如果 HatchObjectType 常数值为 AcGradientObject则使用 AcGradientPatternType 常数.
PatternName(图案名称): String[字符串]; 仅用于输入,如果HatchObjectType 常数值为 acHatchObject, PatternName 包含填充图案名称。如果 HatchObjectType 常数值为 acGradientObject,则 PatternName 包含在 GradientName 中列出的其中一个渐变图案名称。
Associativity(是否关联): Boolean[布尔值]; 仅用于输入,TRUE: 图案填充为关联的。FALSE:图案填充为不关联的。
HatchObjectType(填充对象类型): HatchObjectType; 可选项; 仅用于输入,默认值为AcHatchObjectType 常数值的 AcHatchObject
如果AcHatchObjectType 常数值为 AcGradientObject,则 PatternType AcGradientPatternType 类型,并且 PatternName 包含渐变图案名称。
RetVal: Hatch 对象,新创建的 Hatch 对象。
说明
PatternType 常数值如下:
acHatchPatternTypePredefined        :  选择那些定义在 acad.pat 文件中的图案名称。
acHatchPatternTypeUserDefined       :  使用当前线线型定义的线图案。
acHatchPatternTypeCustomDefined    :    acad.pat 文件名的其它 PAT 中选择图案名称。
创建了 Hatch 对象后,必须使用AppendOuterLoop 方法添加外边界。外边界必须封闭而且必须在任何内边界创建前创建。内边界使用 AppendInnerLoop 方法创建的,一次只能创建一个。
警告! 当创建了 Hatch 对象后,你必须立即追加外边界到 Hatch 对象以便它成为有效的 AutoCAD 对象。如果试图进行调用  AppendOuterLoop 方法以外的其它操作,AutoCAD 将进入无法预测的状态。
  1. Sub 填充图案()* g7 {9 |- O/ g! l
  2.     ' 该示例在模型空间中创建关联的渐变填充图案。+ Q$ q/ X3 a) a3 b( d& F$ R
  3.    
    4 Q9 c% f8 g! e% w% |. s# L; q
  4.     Dim hatchObj As AcadHatch  '定义图案填充变量
    2 N6 v! X5 `- B  _
  5.     Dim patternName As String     '定义填充图案名称
    * T4 p$ w2 F$ S
  6.     Dim PatternType As Long       '定义填充图案类型! G) J# ], f* P. m. Y! U  I9 x) K' X
  7.     Dim bAssociativity As Boolean  '定义关联结果为布尔值
    2 f) b1 ], Z! y6 J- f
  8.     ) I* p( S* u' c9 E
  9.     ' 定义填充图案9 ]7 {5 u1 a' o" R
  10.     patternName = "CYLINDER"
    9 b- @) x' E! N' _
  11.     PatternType = acPreDefinedGradient '0& A' o  ?; E9 a8 V6 e) i# d2 ~
  12.     bAssociativity = True
    9 q  L+ j/ N1 P% @$ S) ~
  13.     4 |) B( s* H& e
  14.     ' 在模型空间中创建关联的 Hatch 对象0 d) ^' ?& C, D8 z3 s
  15.     Set hatchObj = ThisDrawing.ModelSpace.AddHatch(PatternType, patternName, bAssociativity, acGradientObject)
    * l) Z4 @2 D* s5 p) k
  16.     Dim col1 As AcadAcCmColor, col2 As AcadAcCmColor          '定义颜色对象
    4 o0 m* w* j- a
  17.     MsgBox Application.Version   '查看一下版本号,下一句的19即是版本号
    5 d1 ^) ^1 y0 M7 o& J
  18.     Set col1 = AcadApplication.GetInterfaceObject("AutoCAD.AcCmColor.19")  ^, j, f9 n# |+ @# T
  19.     Set col2 = AcadApplication.GetInterfaceObject("AutoCAD.AcCmColor.19")
    ' [. ^# M5 K( e
  20.     Call col1.SetRGB(255, 0, 0)
    5 ]/ Z3 d) U4 j  R7 n. R5 ]
  21.     Call col2.SetRGB(0, 255, 0). t1 L% P8 }# \7 x! S/ I& o
  22.     hatchObj.GradientColor1 = col1      '定义两种渐变色
    0 t8 S# Y% Z+ |+ S: C" J
  23.     hatchObj.GradientColor2 = col2
    * p4 T0 q) ~+ P- o
  24.    
    - W& T. b1 f, c& w
  25.     ' 为填充图案创建外边界(圆)
    3 _" r- d( u/ u- O. T1 U) h
  26.     Dim outerLoop(0 To 0) As AcadEntity
    . |1 S6 z) o. j* B9 ^
  27.     Dim center(0 To 2) As Double
    # d( v- G+ |$ y% }( Y  m
  28.     Dim radius As Double
    3 d7 c# S) I; T  H9 H
  29.     center(0) = 3: center(1) = 3: center(2) = 0: u% E+ g5 ~& b, f6 G0 O" B
  30.     radius = 1
    4 [& B+ h: u4 G! s& P8 ], ^/ B
  31.     Set outerLoop(0) = ThisDrawing.ModelSpace.AddCircle(center, radius)
      L- p1 x; K' }% r2 L. ]
  32.    
      ?9 a! l+ s  m# Q: P/ A& T
  33.     ' 附着外边界到填充图案对象,并显示该填充图案# x2 q7 e3 ^" x! H' O
  34.     hatchObj.AppendOuterLoop (outerLoop)
    : F7 G  w( r: ]! m4 @5 M$ u
  35.     hatchObj.Evaluate; D' I1 S8 H/ D2 M% o1 U
  36.     ThisDrawing.Regen True     '全部重生成!" S6 f) x2 d. L9 _. d4 ~: k* _
  37. End Sub
    6 ?% F/ l( k$ t3 \1 F2 J: }
复制代码
2.11、图案填充(AddHatch).zip (11.58 KB, 下载次数: 2)
 楼主| 发表于 2019-3-29 19:27:46 | 显示全部楼层
本帖最后由 kuangben8 于 2019-4-14 09:47 编辑 # L$ f% Y' S# B' G2 j
  H* ?5 I  w/ b* A$ X( M) C) w
B、填充图案的常用方法
  方法
对应作用
AppendInnerLoop  
向图案填充中附加内边界。
AppendOuterLoop  
向图案填充中附加外边界。
ArrayPolar  
以给定的对象数量、填充角度和中心点创建对象的环形阵列。
ArrayRectangular  
创建对象的二维或三维矩形阵列。
Copy
同一位置复制给定对象。
Delete  
删除指定对象或一组保存了的图层设置。
Evaluate  
计算给定的图案填充或引线。
GetBoundingBox  
返回图元对象边框的最大和最小点。
GetExtensionDictionary  
获取与对象关联的扩展词典。
GetLoopAt  
获取给定索引位置的图案填充边界
GetXData  
获取与对象关联的扩展数据(XData) 。
Highlight  
设置给定对象或给定选择集中所有对象的亮显状态。
InsertLoopAt  
按给定索引在图案填充中插入边界。
IntersectWith  
获取对象与图形中其它对象的相交点。
Mirror  
围绕轴创建平面对象的镜像图像副本。
Mirror3D  
绕由三点定义的平面镜像选定的对象。
Move
将图元对象从源向目标移动。
Rotate  
绕一点旋转图元对象。
Rotate3D
绕三维直线旋转图元对象。
ScaleEntity  
按指定的基点和比例因子来缩放图元对象。
SetPattern  
设置图案填充的图案类型和名称。
SetXData  
设置与对象关联的扩展数据 (外部数据) 。
TransformBy  
给定4×4转换矩阵移动、缩放或旋转对象。
Update
更新图形屏幕的对象。
0 M/ I& h! Z/ S6 o& r

) [# y5 S) U* M+ X1 k
1Object. AppendInnerLoop方法:向图案填充添加内边界。
语法:Object.AppendInnerLoop Loop
Object使用该方法的对象Hatch
LoopVariant[变体] (对象,或对象数组); 仅用于输入构成封闭边界的对象数组。该数组可以由一个或多个对象组成。如果使用多于一个对象,它们的端点必须相接以形成一个环。该边界必须包含以下类型的对象:Line, Polyline, Circle, Ellipse, Spline, Region
说明:
在使用 AddHatch 方法创建了 Hatch 对象后,可使用AppendOuterLoop 添加外边界。外边界必须封闭,而且必须在添加内边界之前创建。
当为图案填充定义定了边界后,使用Evaluate 方法计算填充线并填充该边界,然后使用Regen 方法更新该图案填充的显示。
/ [7 U& o6 j2 E9 s1 }示例参考附件  i: A- T" B; G( D7 H$ K5 |

  q- V6 W* }' W! ~/ _8 K  S
  U; E" g0 r: s9 c
2、object.AppendOuterLoop方法:向图案填充中添加外边界
语法:Object.AppendOuterLoop loop
Object使用该方法的对象Hatch
LoopObject (对象数组); 仅用于输入构成封闭边界的对象数组。该数组可以由一个或多个对象组成。如果使用多于一个对象,它们的端点必须相接以形成一个环。该边界必须包含以下类型的对象: Line, Polyline, Circle, Ellipse, Spline, Region
说明:
在使用 AddHatch 方法创建了 Hatch 对象后,必须添加外边界。外边界必须封闭,而且必须在添加内边界之前创建。在创建了有效的外边界后,可使用 AppendInnerLoop 方法分次每次添加一个任意的内边界。
当为图案填充定义定了边界后,使用Evaluate 方法计算填充线并填充该边界,然后使用Regen 方法更新该图案填充的显示。
3 U2 u7 @4 s: o! f# ?
示例参考附件7 n3 b9 S" ^/ {
9 j9 \8 U: ]+ B$ |) v
. A. T, n* L2 Q0 `8 a2 H
3、填充图案的复制、删除、移动、镜像、旋转、获取交点方法
示例参考附件
    示例代码AppendOuterLoop方法中获取交点失败的原因:边界尺寸太小,绘制的填充图案的线宽超出了边界的尺寸,所以显示的填充图案是一整片区域,而且手动画的直线虽然穿过边界区域,但是并没有超过填充图案的线宽,所以获取不到交点!尝试把边界尺寸扩大到100后重新画线即可。
, N6 t2 j2 Q6 ~) Z, ]

2 }; \9 C/ P' p, P) c5 f, T/ E- r    示例代码验证交点中获取交点失败的原因:两个填充图案的样式相同,并且角度相同,相当于平行线,所以获取不到交点,将其中一个填充图案的角度修改一下之后即可获取交点。
. q+ i  V( \0 {$ w9 f
' x  M) w$ E3 g6 [    注意获取的交点坐标组成的数组中每三个元素组成一个点,所以获取的交点个数等于(数组下标最大值+1)/3
4 }; H. O& B5 W" f4 ?, @- h/ r! m, P) c
5 P& b* [# v" G1 `4 k

3 d& x) j/ {$ w9 z- ]
4、object.GetLoopAt方法:获取给定索引位置的图案填充边界
语法:object.GetLoopAt Index, Loop
Object使用该方法的对象Hatch
IndexInteger[整数]; 仅用于输入从0开始的正整数。
Loop:Variant[变体] (对象或对象数组); 仅用于输出组成边界的一个对象或对象数组。

: L# A! `- _+ D, c示例参考附件
% [* L1 s$ w% X/ u0 Z" }' h6 J* Q+ \% r
, Z( R+ B! q7 `
- t3 z  ^) w: A
5、Object. InsertLoopAt方法:按给定索引在图案填充中插入边界。
语法:object.InsertLoopAt Index, LoopType, Loop
Object使用该方法的对象Hatch
IndexInteger[整数]; 仅用于输入生成图案填充边界的顶点数组中的索引位置。索引必须从 0 开始的正整数。
LoopTypeAcLoopType 常数; 仅用于输入
acHatchLoopTypeDefault
acHatchLoopTypeExternal
acHatchLoopTypePolyline
acHatchLoopTypeDerived
acHatchLoopTypeTextbox
LoopVariant[变体] (对象或对象数组); 仅用于输入形成封闭边界的对象或对象数组。如果使用是的对象数组,它们的端点必须首尾相连以形成回路。边界,或定义边界的数组,可由以下类型的对象组成:
Line, Polyline, Circle, Ellipse, Spline,Region。
示例参考附件

) k3 F1 p8 c1 e
6、Object.ScaleEntity方法:按指定的基点和比例因子来缩放图元对象,是所有对象的方法.
语法: object.ScaleEntity BasePoint, ScaleFactor
Object:使用该方法的对象, 所有图形对象、 AttributeReference
BasePoint: Variant[变体] (三元素双精度数组); 仅用于输入指定基点的三维WCS 坐标。
ScaleFactor: Double[双精度]; 仅用于输入缩放对象的比例因子。对象的尺寸与该比例因子相乘。比例因子大于 1 将放大对象。比例因子在 0 和 1 之间将缩小对象。比例因子必须大于0.0 。
示例参考附件

" ^$ J3 p0 |: D0 L
7、Object.SetPattern方法:设置图案填充的图案类型和名称(仅限于图案填充,而非渐变填充)
语法: object.SetPattern PatternType, PatternName
Object: 使用该方法的对象Hatch。
PatternType: AcPatternType 常数; 仅用于输入
acHatchPatternTypePreDefined        =0从在 acad.pat 文件的定义中选择图案名称。
acHatchPatternTypeUserDefined       =1使用当前线型定义图案线。
acHatchPatternTypeCustomDefined     =2从 acad.pat 文件以外的其它 PAT 文件中选择图案名称。
PatternName: String[字符串]; 仅用于输入图案的名称。填充图案名称最多只允许 34个字符,而且不允许带空格。
示例参考附件

: c) L' `$ P# P$ {: A; S
为防止所占的一个楼层字数限制,特将程序代码打包成附件供下载: 2.11.2、图案填充的常用方法.zip (12.79 KB, 下载次数: 5)
 楼主| 发表于 2019-3-29 19:28:37 | 显示全部楼层
本帖最后由 kuangben8 于 2019-4-13 20:49 编辑
" O" h0 }4 v  |5 r/ d; N: I3 S( L6 T$ ?, s! T0 b" W
C、填充图案的常用属性
  u$ O/ D; G$ M8 M
  属性
对应作用
Application  
获取  Application 对象。只读属性
Area
指定构成弧、圆、椭圆、填充图案、优化多段线、多段线、面域或平面闭合样条曲线的封闭区域的面积。对于圆可修改,其他图形是只读属性
AssociativeHatch  
决定图案填充是否关联。只读属性, 关联性只能在图案填充创建时设置
Document  
获取对象所属的文档(图形)。只读属性
Elevation  
指定图案填充或多段线的当前标高
GradientAngle  
指定渐变填充的角度。
GradientCentered  
指定是否按中心渐变填充。
GradientColor1  
指定渐变填充的起始颜色。针对渐变填充中的双色填充
GradientColor2  
指定渐变填充的结束颜色。针对渐变填充中的双色填充
GradientName  
指定渐变填充的图案名称。
Handle  
获取对象的句柄。只读属性
HasExtensionDictionary  
确定对象是否有扩展词典与其关联。只读属性
HatchObjectType  
指定图案填充的类型为标准或渐变填充。
HatchStyle  
设置图案填充的样式。指孤岛检测样式(普通=0、外部=1、忽略=2)
Hyperlinks  
获取图元的 Hyperlinks 集合。只读属性
ISOPenWidth  
指定 ISO 填充图案的 ISO 笔宽。
Layer  
指定图元的图层。
Linetype  
指定图元的线型。针对的是填充的图案的线型
LinetypeScale  
指定图元的线型比例因子。针对的填充的图案的线型比例,不是图案整体比例
Lineweight  
指定个别图元的线宽或图形的默认线宽。针对填充的图案的线条宽度
Normal  
指定图元的三维法向单位矢量。
NumberOfLoops  
获取图案填充的整体边界数量。只读属性
ObjectID  
获取对象的对象ID。只读属性
OwnerID  
获取所有者(上层)对象的对象ID。只读属性
PatternAngle  
指定填充图案角度。范围在[0,2π]的double类型
PatternDouble  
指定用户定义图案填充是否为双向图案填充。
PatternName  
指定填充图案名称。 只读属性!需用SetPattern方法设置
PatternType  
获取用于图案填充的图案类型。只读属性!需用SetPattern方法设置
PatternScale  
指定填充图案比例。针对的是图案的整体比例,等同于PatternSpace
  
取值范围【>0】
PatternSpace  
指定用户定义填充图案的间距。针对图案的整体比例.等同于PatternScale
  
取值范围【>0】
PlotStyleName
指定一个对象、一组对象或图层的打印样式名称。
TrueColor  
指定对象的真彩色。
Visible
指定对象或应用程序的可见性.
- z2 l) c; L- _' N9 C; N
- g2 P  a5 |& j4 p4 `; |
1Object.HatchStyle属性:设置图案填充的样式,就是填充界面里的孤岛检测样式。有三个属性值。
表示acHatchStyle 常数; 可读写
1acHatchStyleNormal:孤岛检测样式中的“普通”。
指定标准的样式,即普通。该选项从最外面的区域边界向内进行图案填充。如果 AutoCAD 遇到内部边界,则关闭填充,直到遇到另一个边界为止。
2acHatchStyleOuter:孤岛检测样式中的“外部”。
仅填充最外面的区域。该样式也是从最外面的区域边界向内进行图案填充,但是遇到内部边界时会关闭图案填充并且不再打开。
3acHatchStyleIgnore:孤岛检测样式中的“忽略”。
忽略内部结构。该选项使图案填充通过所有的内部对象。
2object.GradientName属性:设置渐变填充图案的名称,String[字符串]; 可读写
渐变填充的图案名称,可以是 LINEAR, CYLINDER, INVCYLINDER, SPHERICAL HEMISPHERICAL, CURVED,INVSPHERICAL, INVHEMISPHERICAL INVCURVED
3object.HatchObjectType属性: 指定图案填充的类型为标准或渐变填充。
AcHatchObjectType 常数; 可读写. 指定以下常数之一。
AcHatchObject = 0   指定为图案填充
AcGradientObject = 1  指定为渐变填充
说明:
该属性为默认值为 0(acHatchObject),创建的是标准的图案填充。
如果该属性的值为 1(acGradientObject),则通过 AddHatch 方法创建的图案填充是渐变的。如果创建了渐变的图案填充,则 PatternType 为 AcGradientPatternType 并且 PatternName 包含的渐变图案名称为LINEAR,CYLINDER, INVCYLINDER, SPHERICAL, HEMISPHERICAL, CURVED, INVSPHERICAL,INVHEMISPHERICAL, 或 INVCURVED。

) [  R, H6 J) G, d- h8 d
4object.ISOPenWidth属性:指定ISO填充图案的ISO笔宽。
ISOPenWidthacISOPenWidth 常数, 对于所有 ISO 填充图案为可读写。指定以下常数之一。
acPenWidth000     0.00 mm
acPenWidth013     0.13 mm
acPenWidth018     0.18mm
acPenWidth025     0.25mm
acPenWidth035     0.35mm
acPenWidth050     0.50mm
acPenWidth070     0.70mm
acPenWidth100     1.00mm
acPenWidth140     1.40mm
acPenWidth200     2.00mm
acPenWidthUnk    未知
5object.PatternDouble属性:指定用户定义图案填充是否为双向图案填充。
PatternDoubleBoolean[布尔值]; 可读写
TRUE: 使用双向图案。 FALSE:不使用双向图案。
系统变量:该属性值保存在系统变量 HPDouble 中。
说明:
如果PatternType被设置为acHatchPatternTypePreDefined或acHatchPatternTypeCustomDefined,那么双向图案属性将不起作用。
6object.PatternName属性:获取填充图案的名称。【只读属性】
7object.PatternType属性:获取用于图案填充的图案类型。【只读属性】
以上两个属性值不可重新赋值修改,只能通过SetPattern方法修改!
常用属性示例参考附件(防止一个楼层字数限制): 2.11.3、图案填充的常用属性.zip (15.83 KB, 下载次数: 1)
发表回复
您需要登录后才可以回帖 登录 | 注册

本版积分规则



Licensed Copyright © 2016-2020 http://www.3dportal.cn/ All Rights Reserved 京 ICP备13008828号

小黑屋|手机版|Archiver|三维网 ( 京ICP备13008828号 )

快速回复 返回顶部 返回列表